using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace WindowsApplication25
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		static void WXShowChanges(string strWhatIsUp, 
			DataTable dataTableChanges)
		{
			if (null == dataTableChanges)
			{
				Console.WriteLine("No changes for DataTable: {0}", 
					strWhatIsUp);
				return;
			}

			int index = 1;

			Console.WriteLine("Changes for DataTable ({0}): {1}", 
				dataTableChanges.TableName,
				strWhatIsUp);
			foreach(DataRow row in dataTableChanges.Rows)
			{
				Console.WriteLine("Row containing changes {0}", index);
				index++;
				foreach (DataColumn column in dataTableChanges.Columns)
				{
					Console.WriteLine(row[column]);
				}
			}
		}


		static void WXShowChanges(string strWhatIsUp,
			DataSet dataSetChanges)
		{
			if (null == dataSetChanges)
			{
				Console.WriteLine("No changes for DataSet: {0}", 
					strWhatIsUp);
				return ;
			}

			Console.WriteLine("Changes for DataSet ({0}): {1}", 
				dataSetChanges.DataSetName,
				strWhatIsUp);
			foreach(DataTable table in dataSetChanges.Tables)
			{
				// Show changes for each table in DataSet
				// using the "table" overload of WXShowChanges
				WXShowChanges("Changed table in DataSet", table);
			}
		}

		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.DataGrid dataGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.button4 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Location = new System.Drawing.Point(8, 8);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(472, 248);
			this.dataGrid1.TabIndex = 4;
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(312, 264);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(96, 40);
			this.button4.TabIndex = 3;
			this.button4.Text = "Only Deleted";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 264);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 40);
			this.button1.TabIndex = 0;
			this.button1.Text = "All Changes";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(104, 264);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(96, 40);
			this.button2.TabIndex = 1;
			this.button2.Text = "Only Modified";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(208, 264);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(96, 40);
			this.button3.TabIndex = 2;
			this.button3.Text = "Only Added";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(488, 309);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.dataGrid1,
																		  this.button4,
																		  this.button3,
																		  this.button2,
																		  this.button1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			DataSet ds = (DataSet)dataGrid1.DataSource;
			WXShowChanges("All changes for DataSet", ds.GetChanges());
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			DataSet ds = (DataSet)dataGrid1.DataSource;
			WXShowChanges("Only modified rows for DataSet", 
				ds.GetChanges(DataRowState.Modified)); 
		}
		private void button3_Click(object sender, System.EventArgs e)
		{
			DataSet ds = (DataSet)dataGrid1.DataSource;
			WXShowChanges("Only added rows for DataSet", 
				ds.GetChanges(DataRowState.Added)); 
		}
		private void button4_Click(object sender, System.EventArgs e)
		{
			DataSet ds = (DataSet)dataGrid1.DataSource;
			WXShowChanges("Only deleted rows for DataSet", 
				ds.GetChanges(DataRowState.Deleted));
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{

			SqlConnection sqlConn = new 
				SqlConnection("server=localhost;uid=sa;pwd=;database=northwind");
			SqlCommand sqlComm = new 
				SqlCommand("select customerid, companyname, contactname, " + 
				"city from customers", sqlConn);
			SqlDataAdapter ad = new SqlDataAdapter(sqlComm);
			DataSet ds = new DataSet();
			sqlConn.Open();
			ad.Fill(ds);
			dataGrid1.DataSource = ds;
		}
	}
}
