Module Module1
    
    Sub Main()
        ' Create a table
        Dim dt As New DataTable("tabAuthors")

        ' Create the ID column, no null allowed and must be unique
        Dim dcID As New DataColumn("AuthorID", GetType(Int32))
        dcID.Unique = True
        dcID.AllowDBNull = False
        dt.Columns.Add(dcID)

        ' Create the FirstName column, no null allowed
        Dim dcAuthorFirstName As New DataColumn("Author_FirstName", GetType(String))
        dcAuthorFirstName.MaxLength = 50
        dcAuthorFirstName.AllowDBNull = False
        dt.Columns.Add(dcAuthorFirstName)

        ' Create the LastName column, no null allowed
        Dim dcAuthorLastName As New DataColumn("Author_LastName", GetType(String))
        dcAuthorLastName.MaxLength = 50
        dcAuthorLastName.AllowDBNull = False
        dt.Columns.Add(dcAuthorLastName)

        ' Add the table to the DataSet
        Dim dsWrox As New DataSet("WroxAuthors")
        dsWrox.Tables.Add(dt)

        ' Add a couple of rows
        Dim r As DataRow = dsWrox.Tables(0).NewRow()
        r("AuthorID") = 1
        r("Author_FirstName") = "Fabio Claudio"
        r("Author_LastName") = "Ferracchiati"
        dsWrox.Tables(0).Rows.Add(r)

        r = dsWrox.Tables(0).NewRow()
        r("AuthorID") = 2
        r("Author_FirstName") = "Alex"
        r("Author_LastName") = "Homer"
        dsWrox.Tables(0).Rows.Add(r)

        ' Add another table
        Dim dtPayment As New DataTable("tabPayments")

        ' Create the ID column, no null allowed and must be unique
        Dim dcIDFK As New DataColumn("AuthorID", GetType(Int32))
        dcIDFK.Unique = True
        dcIDFK.AllowDBNull = False
        dtPayment.Columns.Add(dcIDFK)

        ' Create the PaymentID column, no null allowed and must be unique
        Dim dcPaymentID As New DataColumn("PaymentID", GetType(Int32))
        dcPaymentID.Unique = True
        dcPaymentID.AllowDBNull = False
        dcPaymentID.AutoIncrement = True
        dcPaymentID.AutoIncrementSeed = 1
        dcPaymentID.AutoIncrementStep = 1
        dtPayment.Columns.Add(dcPaymentID)

        ' Create the PaymentID column, no null allowed and must be unique
        Dim dcPayment As New DataColumn("Payment", GetType(System.Data.SqlTypes.SqlMoney))
        dcPayment.AllowDBNull = False
        dtPayment.Columns.Add(dcPayment)

        dsWrox.Tables.Add(dtPayment)

        ' Add a couple of rows
        r = dsWrox.Tables("tabPayments").NewRow()
        r("AuthorID") = 1
        r("Payment") = 20
        dsWrox.Tables("tabPayments").Rows.Add(r)

        r = dsWrox.Tables("tabPayments").NewRow()
        r("AuthorID") = 2
        r("Payment") = 30
        dsWrox.Tables("tabPayments").Rows.Add(r)

        ' Insert a Relation among the tables
        Dim dr As New DataRelation("AuthorsToPaymentRel", dcID, dcIDFK, True)

        dsWrox.Relations.Add(dr)

        ' Print to video
        Dim d As DataRow
        Dim childRow As DataRow

        For Each d In dsWrox.Tables("tabAuthors").Rows
            Console.WriteLine("Author: {0} {1}", d("Author_FirstName"), d("Author_LastName"))
            For Each childRow In d.GetChildRows(dr)
                Console.WriteLine("Payment: {0}$", childRow("Payment"))
            Next
        Next

    End Sub

End Module
