using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace BeginLoadEndRowDataExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			try
			{
				SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");

				// Create Authors DataTable
				DataTable dtAuthors = new DataTable("Authors");

				// Create a DataAdapter to fill the table
				SqlDataAdapter daAuthors = new SqlDataAdapter("SELECT au_id,au_fname,au_lname,phone,address,city,state,zip,contract FROM authors",dbConn);
				daAuthors.Fill(dtAuthors);

				// Create a command builder to implement SQL insert command
				// automatically
				SqlCommandBuilder sqlCB = new SqlCommandBuilder(daAuthors);
				
				// Create a new row
				DataRow drNewAuthor;

				Object[] objNewAuthor = new Object[9];

				// It has the same table schema
				objNewAuthor[0] = "222-22-2222";
				objNewAuthor[1] = "Fabio Claudio";
				objNewAuthor[2] = "Ferracchiati";
				objNewAuthor[3] = "";
				objNewAuthor[4] = "";
				objNewAuthor[5] = "";
				objNewAuthor[6] = "";
				objNewAuthor[7] = "00100";
				objNewAuthor[8] = 1;

				dtAuthors.BeginLoadData();
				drNewAuthor = dtAuthors.LoadDataRow(objNewAuthor,false);
				dtAuthors.EndLoadData();

				// Update the database records
				daAuthors.Update(dtAuthors);

				// Accept DataTable changes
				dtAuthors.AcceptChanges();
			}
			catch (Exception e)
			{
				Console.WriteLine(e.Message);
			}
		}
	}
}
