using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace ExpressionExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Create some columns
			DataColumn dcID = new DataColumn("ID", typeof(System.Int32));
			DataColumn dcQty = new DataColumn("Qty", typeof(System.Int32));
			DataColumn dcPrice = new DataColumn("Price", typeof(System.Int32));
			DataColumn dcTotalPrice = new DataColumn("TotalPrice", typeof(System.Int32));

			// Add the columns to the table
			DataTable dtAuthors = new DataTable("Authors");
			dtAuthors.Columns.Add(dcID);
			dtAuthors.Columns.Add(dcQty);
			dtAuthors.Columns.Add(dcPrice);
			dtAuthors.Columns.Add(dcTotalPrice);

			// Create a DataSet and add the table to it
			DataSet dsAuthors = new DataSet("dsAuthors");
			dsAuthors.Tables.Add(dtAuthors);

			// Add three records to the table
			DataRow drNewRow;

			drNewRow = dtAuthors.NewRow();
			drNewRow["ID"] = 1;
			drNewRow["Qty"] = 10;
			drNewRow["Price"] = 120;
			dtAuthors.Rows.Add(drNewRow);

			drNewRow = dtAuthors.NewRow();
			drNewRow["ID"] = 2;
			drNewRow["Qty"] = 20;
			drNewRow["Price"] = 240;
			dtAuthors.Rows.Add(drNewRow);

			drNewRow = dtAuthors.NewRow();
			drNewRow["ID"] = 3;
			drNewRow["Qty"] = 30;
			drNewRow["Price"] = 360;
			dtAuthors.Rows.Add(drNewRow);

			dtAuthors.AcceptChanges();

			// Create a TotalPrice column
			dsAuthors.Tables[0].Columns["TotalPrice"].Expression = "Qty * Price";

			foreach (DataRow r in dsAuthors.Tables[0].Rows)
				Console.WriteLine(r["TotalPrice"]);
		}
	}
}
