<%@ Page language="c#" Codebehind="EditableDataGrid.aspx.cs" Inherits="DayOfDotNet.EditableDataGrid" %>
<HTML>
	<body style="font: x-small Verdana, Arial, sans-serif;">
		<!-- Begin Web Form -->
		<form id="EditableDataGrid" method="post" runat="server">
			<p>
				<a href="/ADayOfDotNet/">Parent Directory</a>
			</p>
			<!-- Begin DataGrid -->
			<asp:DataGrid id="BookDataGrid" runat="server" AutoGenerateColumns="False" CellPadding="4" CellSpacing="0" Font-Names="Verdana, Arial, sans-serif" BorderColor="Black" BorderWidth="1" GridLines="Horizontal" OnEditCommand="DataGrid_OnEditCommand" OnCancelCommand="DataGrid_OnCancelCommand" OnUpdateCommand="DataGrid_OnUpdateCommand">
				<HeaderStyle Font-Bold="True" Font-Size="small" Font-Name="Arial" BackColor="Maroon" ForeColor="White" />
				<ItemStyle Font-Size="x-small" />
				<AlternatingItemStyle BackColor="Tan" />
				<Columns>
					<asp:EditCommandColumn EditText="Edit" UpdateText="Update" CancelText="Cancel" ItemStyle-VerticalAlign="Top" />
					<asp:BoundColumn DataField="ISBN" HeaderText="ISBN" ReadOnly="True" ItemStyle-Wrap="False" ItemStyle-VerticalAlign="Top" />
					<asp:BoundColumn DataField="Title" HeaderText="Title" ItemStyle-VerticalAlign="Top" />
					<asp:TemplateColumn ItemStyle-VerticalAlign="Top" HeaderText="Info">
						<ItemTemplate>
							<b>Publisher:</b> <a href='<%# DataBinder.Eval(Container.DataItem, "PublisherURL") %>' target="_blank">
								<%# DataBinder.Eval(Container.DataItem, "PublisherName") %>
							</a>
							<br>
							<b>Release Date:</b>
							<%# DataBinder.Eval(Container.DataItem, "ReleaseDate", "{0:d}") %>
							<br>
							<b>Price:</b>
							<%# DataBinder.Eval(Container.DataItem, "Price", "{0:c}") %>
							<br>
							<b>Description:</b>
							<br>
							<blockquote>
								<%# DataBinder.Eval(Container.DataItem, "Description") %>
							</blockquote>
							<p>
								<a href='<%# DataBinder.Eval(Container.DataItem, "AmazonLink") %>'>Buy Now! </a>
							</p>
						</ItemTemplate>
						<EditItemTemplate>
							<b>Publisher:</b>
							<br>
							<asp:DropDownList runat="server" id="Publishers" Font-Names="Verdana, Arial, sans-serif" Font-Size="x-small" DataSource='<%# GetPublisherList() %>' DataTextField="Name" DataValueField="PublisherID" SelectedIndex='<%# GetSelectedPublisher((string)DataBinder.Eval(Container.DataItem, "PublisherName")) %>' />
							<br>
							<b>Release Date:</b>
							<br>
							<asp:Calendar runat="server" id="ReleaseDate" Font-Names="Verdana, Arial, sans-serif" Font-Size="xx-small" SelectedDate='<%# (DateTime)DataBinder.Eval(Container.DataItem, "ReleaseDate") %>' VisibleDate='<%# (DateTime)DataBinder.Eval(Container.DataItem, "ReleaseDate") %>' />
							<br>
							<b>Price:</b>
							<br>
							<asp:TextBox runat="server" id="Price" Font-Names="Verdana, Arial, sans-serif" Font-Size="x-small" Text='<%# DataBinder.Eval(Container.DataItem, "Price") %>' />
							<br>
							<b>Description:</b>
							<br>
							<asp:TextBox runat="server" id="Description" TextMode="Multiline" Rows="5" Font-Names="Verdana, Arial, sans-serif" Font-Size="x-small" Width="350" Text='<%# DataBinder.Eval(Container.DataItem, "Description") %>' />
							<p>
								<b>Amazon Link:</b>
								<br>
								<asp:TextBox runat="server" id="AmazonLink" Font-Names="Verdana, Arial, sans-serif" Font-Size="x-small" Width="350" Text='<%# DataBinder.Eval(Container.DataItem, "AmazonLink") %>' />
							</p>
						</EditItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:DataGrid>
			<!-- End DataGrid -->
		</form>
		<!-- End Web Form -->
	</body>
</HTML>
