Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Drawing
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Configuration

Namespace DayOfDotNet

	Public Class OrderDetailDataGrid
		Inherits System.Web.UI.Page

		Protected OrderDataGrid As DataGrid
		Private ds As DataSet = New DataSet()
		Private customerId As String

		Private Sub Page_Load(sender As object, e As System.EventArgs)
			customerId = HttpContext.Current.Request.QueryString("customerid").ToString()
			Dim sqlStmt As String = _
				"SELECT * FROM Orders WHERE CustomerID = @customerId; " & _
				"SELECT " & _
				"[Orders].CustomerID, " & _
				"[Order Details].OrderID, " & _
				"[Order Details].ProductID, " & _
				"[Products].ProductName, " & _
				"[Categories].CategoryName, " & _
				"[Order Details].UnitPrice, " & _
				"[Order Details].Quantity, " & _
				"[Order Details].Discount, " & _
				"[Order Details].UnitPrice * " & _
				"(1 - [Order Details].Discount) * " & _
				"[Order Details].Quantity AS SubTotal " & _
				"FROM " & _
				"[Order Details] " & _
				"INNER JOIN " & _
				"[Products] ON [Order Details].ProductID = Products.ProductID " & _
				"INNER JOIN " & _
				"[Categories] ON Products.CategoryID = Categories.CategoryID " & _
				"INNER JOIN "& _
				"[Orders] ON [Order Details].OrderID = [Orders].OrderID " & _
				"WHERE " & _
				"[Orders].CustomerID = @customerId"
				
			Dim conString As String = ConfigurationSettings.AppSettings("NWDConString")
			
			Dim sda As SqlDataAdapter = New SqlDataAdapter(sqlStmt, conString)
			sda.SelectCommand.Parameters.Add(New SqlParameter("@customerId", SqlDbType.NChar, 5)).Value = customerId

			sda.Fill(ds)
			ds.Tables(0).TableName = "Orders"
			ds.Tables(1).TableName = "OrderDetail"
			
			OrderDataGrid.DataSource = ds.Tables("Orders")
			OrderDataGrid.DataBind()
		End Sub

		'Use the OnItemCreated event handler to dynamically add an embedded DataGrid
		Protected Sub OrderDataGrid_OnItemDataBound(sender As Object, e As DataGridItemEventArgs)
			'When each row is created in the DataGrid, eval the ItemType
			If e.Item.ItemType = ListItemType.Item XOr e.Item.ItemType = ListItemType.AlternatingItem Then
				'If the ItemType is Item or AlternatingItem, 
				'Create a New DataGrid object named DetailDataGrid
				Dim DetailDataGrid As DataGrid = New DataGrid()
				
				'Format the DataGrid to look cool.
				'***General Formatting***'
				DetailDataGrid.BorderWidth = Unit.Pixel(1)
				DetailDataGrid.Width = Unit.Pixel(640)
				DetailDataGrid.CellPadding = 4
				DetailDataGrid.CellSpacing = 0
				DetailDataGrid.GridLines = GridLines.Horizontal
				DetailDataGrid.BorderColor = Color.FromName("Black")
				'***ItemStyle Formatting***'
				DetailDataGrid.ItemStyle.Font.Name = "Verdana"
				DetailDataGrid.ItemStyle.Font.Size = FontUnit.XSmall
				'***AlternatingItemStyle Formatting***'
				DetailDataGrid.AlternatingItemStyle.BackColor = Color.FromName("LightGray")
				'***HeaderStyle Formatting***'
				DetailDataGrid.ShowHeader = True
				DetailDataGrid.HeaderStyle.BackColor = Color.FromName("Black")
				DetailDataGrid.HeaderStyle.ForeColor = Color.FromName("White")
				DetailDataGrid.HeaderStyle.Font.Bold = True
				DetailDataGrid.HeaderStyle.Font.Size = FontUnit.XSmall

				
				'Do not autogenerate columns.
				DetailDataGrid.AutoGenerateColumns = False
				
				'****Add a series of BoundColumns****'
				Dim bc As BoundColumn = New BoundColumn()				
				'Set the BoundColumn Values
				bc.HeaderText = "ID"
				bc.DataField = "ProductID"
				bc.ItemStyle.Wrap = False
				'Add the BoundColumn to the DetailDataGrid.
				DetailDataGrid.Columns.Add(bc)

				'Do the same for the other columns
				'***Product Name***'
				bc = New BoundColumn()
				bc.HeaderText = "Product"
				bc.DataField = "ProductName"
				bc.ItemStyle.Wrap = True
				DetailDataGrid.Columns.Add(bc)

				'***Category Name***'
				bc = New BoundColumn()
				bc.HeaderText = "Category"
				bc.DataField = "CategoryName"
				bc.ItemStyle.Wrap = False
				DetailDataGrid.Columns.Add(bc)

				'***Unit Price***'
				bc = New BoundColumn()
				bc.HeaderText = "Unit Price"
				bc.DataField = "UnitPrice"
				bc.DataFormatString="{0:c}"
				bc.ItemStyle.Wrap = False
				DetailDataGrid.Columns.Add(bc)

				'***Quantity***'
				bc = New BoundColumn()
				bc.HeaderText = "Qnt"
				bc.DataField = "Quantity"
				bc.ItemStyle.Wrap = False
				DetailDataGrid.Columns.Add(bc)
				
				'***Discount***'
				bc = New BoundColumn()
				bc.HeaderText = "Dsc"
				bc.DataField = "Discount"
				bc.DataFormatString="{0:p}"
				bc.ItemStyle.Wrap = False
				DetailDataGrid.Columns.Add(bc)

				'***SubTotal***'
				bc = New BoundColumn()
				bc.HeaderText = "SubTotal"
				bc.DataField = "SubTotal"
				bc.DataFormatString="{0:c}"
				bc.ItemStyle.Wrap = False
				DetailDataGrid.Columns.Add(bc)
				
				'****End BoundColumns****'
				
				
				'Get the OrderDetail DataView and filter it 
				'for the current OrderID
				Dim _detail As DataView= ds.Tables("OrderDetail").DefaultView
				_detail.RowFilter = "OrderID='" & e.Item.Cells(0).Text & "'"
				
				'Bind the DataGrid.
				DetailDataGrid.DataSource = _detail
				DetailDataGrid.DataBind()
				
				'Add the DetailDataGrid to the OrderDataGrid
				'in the 2nd column of the current row
				e.Item.Cells(1).Controls.Add(DetailDataGrid)
			End If
		End Sub
	End Class
End Namespace