namespace PowerOfDotNet.Clubs.Board
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;

	/// <summary>
	///		MainFragment   Դϴ.
	/// </summary>
	public abstract class ClubMainFragment : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.Image imgTitle;
		protected string _Target;
		protected System.Web.UI.WebControls.DataList datlstSimple;

		private PowerOfDotNet.Components.BoardClubInfo _blInfo;
		private int _boardId;

		public string BoardID
		{
			get
			{
				return _boardId.ToString();
			}
			set
			{
				_boardId = Convert.ToInt32(value);
			}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardClubInfo)this.GetObjectFromCache("BoardClubTableInfo" + _boardId);
			if (_blInfo == null)
			{
				PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
				_blInfo = db.GetBoardInfo(_boardId);

				this.SetObjectToCache("BoardClubTableInfo" + _boardId, _blInfo, 30);
			}
			imgTitle.ImageUrl = _blInfo.BBSImage;
			_Target = GetLink(_blInfo.BBSPageNameList);

			datlstSimple.DataSource = CtrateDataSource();
			this.DataBind();
		}

		private ICollection CtrateDataSource()
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("Subject", typeof(string)));
			dt.Columns.Add(new DataColumn("Writer", typeof(string)));

			PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
			SqlDataReader sdr;

			sdr = db.GetSqlRecentSubject(_blInfo.BBSTable, 7);
			while (sdr.Read())
			{
				dr = dt.NewRow();

				int treeId = (int)sdr["TreeID"];
				string sSpace = "";
				// 鿩
				for (int i=0;i<treeId;i++) 	sSpace += "&nbsp;&nbsp;";

				dr[0] = sSpace + sdr["Subject"].ToString(); 
				dr[1] = sdr["Writer"].ToString();
	
				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);
			return dv;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
