using System;
using System.IO;
using System.Collections;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text.RegularExpressions;

namespace Chapter04.Ex07
{
	public class Chap04_Ex07 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolder1;

		private Button _btnOk;
		private TextBox _txtInput;
		private Label _lblLabel;

		private const string BUTTON = "{{ư}}";
		private const string TEXTBOX = "{{ؽƮڽ}}";
		private const string LABEL = "{{̺}}";

		private const string DATE = "{{¥}}";
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			skinLoad();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void skinLoad()
		{
			_btnOk = new Button();
			_txtInput = new TextBox();
			_lblLabel = new Label();

			_lblLabel.ForeColor = System.Drawing.Color.DeepPink;
			_lblLabel.Text = "̺";
			_btnOk.Text = "ؽƮڽ  Label ű";
			_btnOk.Click += new System.EventHandler(this.btnOk_Click);

			string skinFile = "Skin.skn";
			FileStream fs = File.OpenRead(Page.MapPath(skinFile));
			StreamReader sr = new StreamReader((Stream)fs, System.Text.Encoding.Default);
			string strSkin = sr.ReadToEnd();
			sr.Close();

			Regex skinRegex = new Regex("{{[^{}]+}}");
			MatchCollection mc = skinRegex.Matches(strSkin);

			if (mc.Count > 0)
			{
				for (int i=0; i < mc.Count; i++) 
				{
					string frontPortion, backPortion;

					if (i == 0)
					{
						frontPortion = GetFrontPortion(strSkin, mc, i);
						if (frontPortion != String.Empty)
							AddLiteralControl(frontPortion);

						SetupEachControl(mc[i]);

						backPortion = GetBackPortion(strSkin, mc, i);
						if (backPortion != String.Empty)
							AddLiteralControl(backPortion);
					}
					else
					{
						SetupEachControl(mc[i]);

						backPortion = GetBackPortion(strSkin, mc, i);
						if (backPortion != String.Empty)
							AddLiteralControl(backPortion);
					}
				}
			}
		}

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			_lblLabel.Text = _txtInput.Text;
		}

		private void SetupEachControl(Match m)
		{
			string symbolName = m.Value;

			switch (symbolName)
			{
				case BUTTON :
					PlaceHolder1.Controls.Add(_btnOk);
					break;
				case TEXTBOX :
					PlaceHolder1.Controls.Add(_txtInput);
					break;
				case LABEL :
					PlaceHolder1.Controls.Add(_lblLabel);
					break;
				case DATE :
					AddLiteralControl(DateTime.Now.ToString("yyyy MM dd"));
					break;
			}
		}

		private void AddLiteralControl(string text)
		{
			PlaceHolder1.Controls.Add(new LiteralControl(text));
		}

		private string GetFrontPortion(string origin, MatchCollection mc, int index)
		{
			if (index == 0)
				return origin.Substring(0, mc[index].Index);
			else
				return origin.Substring(mc[index-1].Index+mc[index-1].Length, 
					mc[index].Index - (mc[index-1].Index+mc[index-1].Length));
		}

		private string GetBackPortion(string origin, MatchCollection mc, int index)
		{
			if (index == mc.Count-1)
				return origin.Substring(mc[index].Index + mc[index].Length);
			else
				return origin.Substring(mc[index].Index + mc[index].Length, 
					mc[index + 1].Index - (mc[index].Index+mc[index].Length));
		}
	}
}
