using System;
using System.Data;
using System.Data.SqlClient;
using System.EnterpriseServices;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace MemoDb
{
	[Transaction(TransactionOption.Required)]
	[ObjectPooling(MinPoolSize=1,MaxPoolSize=5)]
	[JustInTimeActivation(true)]
	[ConstructionEnabled(Enabled = true,
		 Default = "server=localhost;database=AspDotNetBook;uid=AspDotNet;pwd=aspdotnet")]
	public class MemoDB_Tx : ServicedComponent
	{
		private SqlConnection conn;
		private string connStr;

		public MemoDB_Tx()
		{
		}

		protected override void Construct(string constructString) 
		{
			connStr = constructString;
		}

		protected override void Activate()
		{
			conn = new SqlConnection(connStr);
		}

		protected override void Deactivate()
		{
			if (conn != null)
			{
				if (conn.State != ConnectionState.Closed )
					conn.Close();

				conn.Dispose();
				conn = null;
			}
		}

		protected override bool CanBePooled()
		{
			return true;
		}

		[AutoComplete]
		public int UpdateMemo(int id,string content)
		{
			string sql = "UPDATE tbMemo ";
			sql += "SET memo = '" + content + "'";
			sql += "WHERE id = " + id;

			SqlCommand command = new SqlCommand(sql, conn);
			command.CommandType = CommandType.Text;

			conn.Open();
			int efCount = 0;

			try
			{
				efCount = command.ExecuteNonQuery();
			}
			catch( Exception ex )
			{
				throw ex;
			}

			return efCount;
		}

		[AutoComplete]
		public int DeleteMemo(int id)
		{
			string sql = "DELETE  from tbMemo ";
			sql += "WHERE id = " + id;

			SqlCommand command = new SqlCommand(sql, conn);
			command.CommandType = CommandType.Text;

			conn.Open();
			int efCount = 0;

			try
			{
				efCount = command.ExecuteNonQuery();
			}
			catch( Exception ex )
			{
				throw ex;
			}

			return efCount;
		}

		[AutoComplete]
		public int InsertMemo(string memo)
		{
			string sql = "INSERT into tbMemo ";
			sql += "(memo) ";
			sql += "values ('" + memo + "') ";

			SqlCommand command = new SqlCommand(sql, conn);
			command.CommandType = CommandType.Text;

			conn.Open();
			int efCount = 0;

			try
			{
				efCount = command.ExecuteNonQuery();
			}
			catch( Exception ex )
			{
				throw ex;
			}

			return efCount;
		}
	}
}
