using System;
using System.Collections;
using System.Drawing;
using System.Drawing.Imaging;

namespace Chapter13.Ex03
{
	public class Chap13_Ex03 : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			ArrayList values = new ArrayList();

			values.Add(10);
			values.Add(55);
			values.Add(34);
			values.Add(67);
			values.Add(3);

			DrawGraph(values);
		}

		private void DrawGraph(ArrayList values)
		{
			const int bitmapWidth = 400;
			const int bitmapHeigth = 400;

			Bitmap bitmap = new Bitmap(bitmapWidth, bitmapHeigth);
			Graphics graphics = Graphics.FromImage(bitmap);
			graphics.FillRectangle(new SolidBrush(Color.White), 0,0, bitmapWidth, bitmapHeigth);

			int maxValue = 0;
			foreach (int val in values)
				if (maxValue < val)
					maxValue = val;

			SolidBrush graphBrush = new SolidBrush(Color.Blue);
			SolidBrush fontBrush = new SolidBrush(Color.Purple);
			Font font = new Font("", 9.0F);
			int curentY = 5;
			for (int i=0; i<values.Count; i++)
			{
				int graphWidth = (int)(((double)(int)values[i] / (double)maxValue) * (double)350);

				graphics.FillRectangle(graphBrush, 10, curentY, graphWidth, 15);
				graphics.DrawString(values[i].ToString(), font,fontBrush, (float)(graphWidth+15), (float)curentY);
				curentY += 25;
			}

			bitmap.Save(Response.OutputStream, ImageFormat.Gif);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
