using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

namespace Chapter13.Ex05
{
	public class ImageComposition : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			string[] aSel = Request.QueryString["Selected"].Split(new Char[] {','});

			System.Drawing.Image oBitmap, oResult;
			//Bitmap oBitmap, oResult;
			Graphics oGraphics;

			//Ͼ 
			Color lowerColor = Color.FromArgb(255,255,255);
			Color upperColor = Color.FromArgb(255,255,255);

			ImageAttributes imageAttr = new ImageAttributes();
			imageAttr.SetColorKey(lowerColor, upperColor);

			oResult = new Bitmap( 100, 100 );
			oGraphics = Graphics.FromImage( oResult );
			oGraphics.FillRectangle(new SolidBrush(Color.White), new Rectangle(0,0,100,100));
			oGraphics.CompositingMode = CompositingMode.SourceOver;
			//oGraphics.CompositingQuality = CompositingQuality.GammaCorrected;

			for (int i=0;i<aSel.Length;i++)
			{
				try 
				{
					string sPath = Page.MapPath(Request.FilePath);
					sPath = sPath.Substring(0, sPath.LastIndexOf(@"\")+1);
					oBitmap = new Bitmap(sPath + "images/" + aSel[i] + ".gif");
					Rectangle rect = new Rectangle(0, 0, oBitmap.Width, oBitmap.Height);
					oGraphics.DrawImage(oBitmap,         // Image
						rect,            // Dest. rect.
						0,               // srcX
						0,               // srcY
						oBitmap.Width,             // srcWidth
						oBitmap.Height,             // srcHeight
						GraphicsUnit.Pixel, // srcUnit
						imageAttr);      // ImageAttributes
				}
				catch
				{
				}
			}

			oResult.Save( Response.OutputStream, ImageFormat.Gif );
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
