using System;
using System.IO;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;

namespace Chapter16.BLOB
{
	public class ImageUpload : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataList DataList1;
		protected System.Web.UI.WebControls.Button btnUpload;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileImage;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
				Bind();
		}

		protected void Bind()
		{
			string strSqlConn = 
				ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select id, name from tbBLOB";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;
			try 
			{
				dr = cmdSql.ExecuteReader();
				DataList1.DataSource = dr;
				DataList1.DataBind();
				dr.Close();
			}
			catch {}
			finally
			{
				sqlConn.Close();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.btnUpload.Click += new System.EventHandler(this.btnUpload_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void btnUpload_Click(object sender, System.EventArgs e)
		{
			String strFileName = Path.GetFileName(fileImage.PostedFile.FileName);
			int intSize = fileImage.PostedFile.ContentLength;
			Byte[] FileByteArray = new Byte[intSize];
			Stream StreamObj = fileImage.PostedFile.InputStream;
			string sqlStr = "insert into tbBLOB ";
			sqlStr += "(name, size, type, image) ";
			sqlStr += "values (@name, @size, @type, @image) ";

			SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlCommand cmd = new SqlCommand(sqlStr, conn);

			StreamObj.Read(FileByteArray,0,intSize);

			cmd.Parameters.Add(new SqlParameter("@name", SqlDbType.VarChar, 50)).Value = strFileName;
			cmd.Parameters.Add(new SqlParameter("@size", SqlDbType.BigInt)).Value = intSize;
			cmd.Parameters.Add(new SqlParameter("@type", SqlDbType.VarChar, 30)).Value = fileImage.PostedFile.ContentType;
			cmd.Parameters.Add(new SqlParameter("@image", SqlDbType.Image)).Value = FileByteArray;

			conn.Open();
			try 
			{
				cmd.ExecuteNonQuery();
			}
			catch (	Exception err) 
			{
				string s = err.Message;
			}
			finally
			{
				conn.Close();
			}
			
			Bind();
		}
	}
}
