using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI.WebControls;

namespace Chapter18.Ex04
{
	public class Chap18_Ex04 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.DataGrid DataGrid2;
		protected System.Web.UI.WebControls.DataGrid DataGrid3;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				DataSet ds = GetDsParentChild();

				DataGrid1.DataSource = ds;
				DataGrid1.DataMember = "Parent";
				DataGrid1.DataBind();

				DataGrid2.DataSource = ds;
				DataGrid2.DataMember = "Child";
				DataGrid2.DataBind();
			}
		}

		private DataSet GetDsParentChild()
		{
			DataSet ds = new DataSet();

			DataTable dtParent = new DataTable("Parent");
		
			DataColumn dc = new DataColumn("id", typeof(Int32));
			dc.AutoIncrement = true;
			dc.AutoIncrementSeed = 1;
			dc.AutoIncrementStep = 1;
			dc.Unique = true;
			dtParent.Columns.Add(dc);

			dtParent.PrimaryKey = new DataColumn[] {dc};

			dc = new DataColumn("stringValue", typeof(string));
			dc.MaxLength = 50;
			dtParent.Columns.Add(dc);

			dc = new DataColumn("dateTimeValue", typeof(DateTime));
			dtParent.Columns.Add(dc);

			DataTable dtChild = new DataTable("Child");

			dc = new DataColumn("id", typeof(Int32));

			dc.AutoIncrement = true;
			dc.AutoIncrementSeed = 1;
			dc.AutoIncrementStep = 1;
			dc.Unique = true;
			dtChild.Columns.Add(dc);

			dtChild.PrimaryKey = new DataColumn[] {dc};

			dc = new DataColumn("parentId", typeof(Int32));
			dc.AllowDBNull = false;
			dtChild.Columns.Add(dc);

			dc = new DataColumn("stringValue", typeof(string));
			dc.MaxLength = 50;
			dtChild.Columns.Add(dc);

			ds.Tables.Add(dtParent);
			ds.Tables.Add(dtChild);

			ds.Relations.Add("ParentChildRelation", 
				ds.Tables["Parent"].Columns["id"], 
				ds.Tables["Child"].Columns["parentId"]);

			for (int i=0; i<3; i++ )
			{
				DataRow dr = dtParent.NewRow();

				dr["stringValue"] = "Parent ׽Ʈ  " + (i + 1);
				dr["dateTimeValue"] = DateTime.Now;

				dtParent.Rows.Add(dr);
			}

			for (int i=0; i<5; i++ )
			{
				DataRow dr = dtChild.NewRow();

				dr["stringValue"] = "Child ׽Ʈ  " + (i + 1);
				dr["parentId"] = (i + 2) / 2;

				dtChild.Rows.Add(dr);
			}

			return ds;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.SelectedIndexChanged += new System.EventHandler(this.DataGrid1_SelectedIndexChanged);
			this.DataGrid2.SelectedIndexChanged += new System.EventHandler(this.DataGrid2_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void DataGrid1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataSet ds = GetDsParentChild();
			DataGrid dataGrid = (DataGrid)sender;
			//õ  DataGridItem ü ´.
			DataGridItem dgItem = dataGrid.Items[dataGrid.SelectedIndex];

			//õ  id ´
			int id = int.Parse(dgItem.Cells[1].Text);
			DataRow parentRow = (ds.Tables["Parent"].Select("id=" + id))[0];
			//DataRow parentRow = ds.Tables["Parent"].Rows.Find(id);
			DataRow[] childRows = parentRow.GetChildRows("ParentChildRelation");

			DataTable dtChild = ds.Tables["Child"].Clone();
			foreach (DataRow dr in childRows)
			{
				dtChild.ImportRow(dr);
			}
			DataGrid3.DataSource = dtChild.DefaultView;
			DataGrid3.DataBind();
		}

		private void DataGrid2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataSet ds = GetDsParentChild();
			DataGrid dataGrid = (DataGrid)sender;
			//õ  DataGridItem ü ´.
			DataGridItem dgItem = dataGrid.Items[dataGrid.SelectedIndex];

			//õ  id ´
			int id = int.Parse(dgItem.Cells[1].Text);
			DataRow childRow = (ds.Tables["Child"].Select("id=" + id))[0];
			//DataRow childRow = ds.Tables["Child"].Rows.Find(id);
			DataRow parentRow = childRow.GetParentRow("ParentChildRelation");

			DataTable dtParent = ds.Tables["Parent"].Clone();
			dtParent.ImportRow(parentRow);

			DataGrid3.DataSource = dtParent.DefaultView;
			DataGrid3.DataBind();
		}
	}
}
