using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter19
{
	public class CompareEvent : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Button Button2;

		private bool itemDataBoundOccured = false;
		private bool itemCreatedOccured = false;

		private int itemDataBoundOccuredCount = 0;
		private int itemCreatedOccuredCount = 0;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				DataGrid1.DataSource = GetData();
				DataGrid1.DataBind();
			}
		}

		private SqlDataReader GetData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;

			dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.DataGrid1_ItemCreated);
			this.DataGrid1.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.DataGrid1_ItemDataBound);
			this.Button2.Click += new System.EventHandler(this.Button2_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		private void DataGrid1_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				DbDataRecord dataRecord = (DbDataRecord)e.Item.DataItem;
				if (dataRecord != null)
					Response.Write("ItemDataBound ((DbDataRecord)DataItem)[\"id\"] : " + dataRecord["id"].ToString() + "<br>");
				else
					Response.Write("ItemDataBound ((DbDataRecord)DataItem) : null" + "<br>");

				string cell1 = e.Item.Cells[1].Text;
				if (cell1 == String.Empty)
					Response.Write("ItemDataBound Cells[1] : (Empty)" + "<br>");
				else
					Response.Write("ItemDataBound Cells[1] : " + e.Item.Cells[1].Text + "<br>");
			}

			itemDataBoundOccured = true;
			itemDataBoundOccuredCount++;
		}

		
		private void DataGrid1_ItemCreated(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{

			if (e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				//DataItem null̴.
				DbDataRecord dataRecord = (DbDataRecord)e.Item.DataItem;
				if (dataRecord != null)
					Response.Write("ItemCreated ((DbDataRecord)DataItem)[\"id\"] : " + dataRecord["id"].ToString() + "<br>");

				else
					Response.Write("ItemCreated ((DbDataRecord)DataItem) : null" + "<br>");

				//Cells ִ.
				string cell1 = e.Item.Cells[1].Text;
				if (cell1 == String.Empty)
					Response.Write("ItemCreated Cells[1] : (Empty)" + "<br>");
				else
					Response.Write("ItemCreated Cells[1] : " + e.Item.Cells[1].Text + "<br>");
			}

			itemCreatedOccured = true;
			itemCreatedOccuredCount++;
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			Response.Write("<br>");
			if(itemDataBoundOccured)
			{
				Response.Write("ItemDataBound " + 
					itemDataBoundOccuredCount + " ߻!<br>");
			}

			if(itemCreatedOccured)
			{
				Response.Write("ItemCreated " + 
					itemCreatedOccuredCount + " ߻!<br>");
			}
		}

		private void Button2_Click(object sender, System.EventArgs e)
		{
			DataGrid1.DataSource = GetData();
			DataGrid1.DataBind();
		}
	}
}
