using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Button
{
	/// <summary>
	/// SimpleButton   Դϴ.
	/// </summary>
	[DefaultProperty("Text"), 
		ToolboxData("<{0}:SimpleButton runat=server></{0}:SimpleButton>")]
	public class SimpleButton : WebControl, IPostBackEventHandler
	{
		public event CommandEventHandler Command;
		public event EventHandler Click;

		#region Ӽ
		[Bindable(true), 
			Category("Appearance"), 
			DefaultValue("")] 
		public string Text 
		{
			get
			{
				object o = ViewState["text"];
				return (o == null) ? String.Empty : (string)o;
			}

			set
			{
				ViewState["text"] = value;
			}
		}

		[Bindable(true), 
		Category("Behavior"), 
		DefaultValue("")] 
		public string CommandName
		{
			get
			{
				object o = ViewState["commandName"];
				return (o == null) ? String.Empty : (string)o;
			}

			set
			{
				ViewState["commandName"] = value;
			}
		}

		[Bindable(true), 
		Category("Behavior"), 
		DefaultValue("")] 
		public string CommandArgument
		{
			get
			{
				object o = ViewState["CommandArgument"];
				return (o == null) ? String.Empty : (string)o;
			}

			set
			{
				ViewState["CommandArgument"] = value;
			}
		}

		#endregion

		#region ޼ҵ

		public SimpleButton() : base(HtmlTextWriterTag.Input)
		{
		}

		/*
		/// <summary> 
		///  Ʈ   Ű  մϴ.
		/// </summary>
		/// <param name="output">   HTML ۼ </param>
		protected override void Render(HtmlTextWriter output)
		{
			output.Write(Text);
		}
		*/

		protected override void RenderContents(System.Web.UI.HtmlTextWriter writer)
		{
			base.RenderContents(writer);
		}

		protected override void AddAttributesToRender(System.Web.UI.HtmlTextWriter writer)
		{
			//'name' Ǿ LoadPostData ̺Ʈ ߻Ѵ.
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID);
			writer.AddAttribute(HtmlTextWriterAttribute.Type, "submit");
			writer.AddAttribute(HtmlTextWriterAttribute.Value, Text);

			base.AddAttributesToRender(writer);
		}

		public void RaisePostBackEvent(string eventArgument)
		{
			OnCommand();
			OnClick();
		}

		protected void OnCommand()
		{
			if (Command != null)
				Command(this, new CommandEventArgs(CommandName, CommandArgument));
		}

		protected void OnClick()
		{
			if (Click != null)
				Click(this, EventArgs.Empty);
		}

		#endregion 
	}
}
