using System;
using System.Collections;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Chapter21
{
	public class TemplatedListTest : System.Web.UI.Page
	{
		protected CustomControls.TemplatedControls.TemplatedList myList;
		protected System.Web.UI.WebControls.Label infoLabel;

		private int selectedIndex = -1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack) 
			{
				LoadData();
			}
		}

		private void LoadData() 
		{
			ArrayList data = new ArrayList();

			for (int i = 0; i < 10; i++) 
			{
				data.Add("Item " + i);
			}

			myList.DataSource = data;
			myList.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.myList.ItemCreated += new CustomControls.TemplatedControls.TemplatedListItemEventHandler(this.myList_ItemCreated);
			this.myList.SelectedIndexChanged += new System.EventHandler(this.myList_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void myList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (selectedIndex != -1) 
			{
				Control item = myList.Controls[0].Controls[selectedIndex];
				Button selectButton = (Button)item.FindControl("selectButton");
				selectButton.Enabled = true;
			}

			selectedIndex = myList.SelectedIndex;
			infoLabel.Text = "SelectedIndex: " + selectedIndex;

			if (selectedIndex != -1) 
			{
				Control item = myList.Controls[0].Controls[selectedIndex];
				Button selectButton = (Button)item.FindControl("selectButton");
				selectButton.Enabled = false;
			}
		}

		private void myList_ItemCreated(object sender, CustomControls.TemplatedControls.TemplatedListItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.SelectedItem) 
			{
				selectedIndex = e.Item.ItemIndex;

				Button selectButton = (Button)e.Item.FindControl("selectButton");
				selectButton.Enabled = false;
			}		
		}
	}
}
