using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Event
{
	public class PostBackDataMulti : WebControl, IPostBackDataHandler
	{
		private bool textChanged, indexChanged;

		public event EventHandler TextChanged;
		public event EventHandler IndexChanged;

		public string Text {
			get	{
				object o = ViewState["text"];
				return (o == null) ? String.Empty : (string)o;
			}
			set	{ViewState["text"] = value;}
		}

		public int SelectedIndex {
			get	{
				object o = ViewState["SelectedIndex"];
				return (o == null) ? -1 : (int)o;
			}
			set	{ViewState["SelectedIndex"] = value;}
		}

		public bool LoadPostData(string postDataKey, System.Collections.Specialized.NameValueCollection postCollection)
		{
			int select = int.Parse(postCollection[postDataKey]);
			string input = postCollection[postDataKey+"Input"];

			textChanged = indexChanged = false;

			if (!(SelectedIndex == -1 && select == 0) && select != SelectedIndex) {
				SelectedIndex = select;
				indexChanged = true;
			}

			if (Text != input) {
				Text = input;
				textChanged = true;
			}

			return indexChanged || textChanged;
		}

		public void RaisePostDataChangedEvent()
		{
			if (textChanged && TextChanged != null)
				TextChanged(this, EventArgs.Empty);

			if (indexChanged && IndexChanged != null)
				IndexChanged(this, EventArgs.Empty);
		}

		protected override void Render(System.Web.UI.HtmlTextWriter writer)
		{
			writer.Write("Select Ʈ : ");
			//Է Ʈ    ϳ Ʈ UniqueID 
			//name Ӽ ؾ LoadPostData ޼ҵ尡 ȣȴ.
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID);
			writer.RenderBeginTag(HtmlTextWriterTag.Select);

			for (int i=0;i<10;i++) {
				if (SelectedIndex == i)
					writer.AddAttribute(HtmlTextWriterAttribute.Selected, null);
				writer.AddAttribute(HtmlTextWriterAttribute.Value, i.ToString());
				writer.RenderBeginTag(HtmlTextWriterTag.Option);
				writer.Write(i + "° ");
				writer.RenderEndTag();
				writer.WriteLine();
			}
			writer.RenderEndTag();

			writer.Write("<br>");
			writer.Write("Input Ʈ : ");

			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID+"Input");
			writer.AddAttribute(HtmlTextWriterAttribute.Type, "input");
			writer.AddAttribute(HtmlTextWriterAttribute.Value, Text);
			writer.RenderBeginTag(HtmlTextWriterTag.Input);
			writer.RenderEndTag();
		}
	}
}
