using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Event
{
	public class PostBackEvent : WebControl, IPostBackEventHandler
	{
		public event EventHandler Click;

		public PostBackEvent() : base(HtmlTextWriterTag.Input) {}

		protected override void AddAttributesToRender(HtmlTextWriter writer)
		{
			//'name' Ǿ LoadPostData ̺Ʈ ߻Ѵ.
			writer.AddAttribute(HtmlTextWriterAttribute.Name, UniqueID);
			writer.AddAttribute(HtmlTextWriterAttribute.Type, "submit");
			writer.AddAttribute(HtmlTextWriterAttribute.Value, "IPostBackEventHandler ̽ ");

			base.AddAttributesToRender(writer);
		}

		public void RaisePostBackEvent(string eventArgument)
		{
			OnClick();
		}

		protected void OnClick()
		{
			if (Click != null)
				Click(this, EventArgs.Empty);
		}
	}
}