using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.PracticalControls
{
	[ToolboxData("<{0}:RollOverImageButton runat=server></{0}:RollOverImageButton>")]
	public class RollOverImageButton : ImageButton
	{
		private string _ImageUrlOver = String.Empty;
		private bool _RoolOver = true;
		private bool isRuntime = false;

		private const string ImagePreloadScript = @"
<script language=""javascript"">
<!--
function __preloadImages(a) {
	var d=document; 

  	if(!d.MM_p) d.MM_p=new Array();
	var i;
	var j=d.MM_p.length;
	
	for(i=0; i<a.length; i++){
		d.MM_p[j]=new Image; 
		d.MM_p[j++].src=a[i];
	}
}

if(typeof(aPreloadIMages) != ""undefined"")
{
	__preloadImages(aPreloadIMages);
}
//-->
</script>
		";

		[Editor("System.Web.UI.Design.ImageUrlEditor, System.Design","System.Drawing.Design.UITypeEditor"),
		Category("Appearance"),
		Description("ѿ ̹.")]
		public string ImageUrlOver {
			get	{return _ImageUrlOver;}
			set	{_ImageUrlOver = value;}
		}

		[Category("Behavior"),
		DefaultValue(true),
		Description("ѿ .")]
		public bool RollOver {
			get	{return _RoolOver;}
			set	{_RoolOver = value;}
		}

		override protected void OnPreRender(EventArgs e) 
		{
			base.OnPreRender(e);

			isRuntime = true;
			if (CanRollOver() && DetermineRenderUplevel()) {
				//aPreloadIMages 迭 ѿ ̹ ̸ ߰Ѵ.
				Page.RegisterArrayDeclaration("aPreloadIMages", "\""+ _ImageUrlOver + "\"");
				if (!Page.IsStartupScriptRegistered("ImagePreloadScript"))
					Page.RegisterStartupScript("ImagePreloadScript", ImagePreloadScript);
			}
		}

		protected override void AddAttributesToRender(HtmlTextWriter writer) 
		{
			base.AddAttributesToRender(writer);   

			if (CanRollOver() && DetermineRenderUplevel()) {
				writer.AddAttribute("onMouseOver", "this.src='" + _ImageUrlOver + "';");
				writer.AddAttribute("onMouseOut", "this.src='" + ImageUrl + "'");
			}
		}

		private bool CanRollOver()
		{
			return _RoolOver && 
				!_ImageUrlOver.Equals(String.Empty) && 
				!ImageUrl.Equals(String.Empty);
		}

		protected virtual bool DetermineRenderUplevel() 
		{
			if (!isRuntime) return false;

			Page page = Page;
			return (page.Request.Browser.W3CDomVersion.Major >= 1
				&& page.Request.Browser.EcmaScriptVersion.CompareTo(new Version(1, 2)) >= 0);
		}
	}
}