using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CustomControls.TemplatedControls
{
	[ParseChildren(true)]
	public class TemplatedControl1 : Control, INamingContainer
	{
		private ITemplate  myTemplate = null;
		private String message = null;

		public String Message {
			get {return message;}
			set {message = value;}
		}

		[PersistenceMode(PersistenceMode.InnerProperty),
		TemplateContainer(typeof(TemplateItem))]
		public ITemplate MyTemplate {
			get {return myTemplate;}
			set {myTemplate = value;}
		}

		protected override void CreateChildControls() 
		{
			Controls.Clear();

			TemplateItem item = new TemplateItem(message);
			myTemplate.InstantiateIn(item);
			item.DataBind();
			Controls.Add(item);
		}

		public class TemplateItem : Control, INamingContainer 
		{
			private String message = null;

			public TemplateItem(String msg) 
			{
				message = msg;
			}

			public String Message {
				get {return message;}
				set {message = value;}
			}
		}
	}
}
