using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using System.Diagnostics;
using System.Text.RegularExpressions;
using System.Drawing.Design;

namespace CustomControls.Validators
{
	/// <summary>
	/// SimpleRegexValidator   Դϴ.
	/// </summary>
	[
	ToolboxData("<{0}:SimpleRequiredFieldValidator2 runat=server ErrorMessage=\"SimpleRequiredFieldValidator1\"></{0}:SimpleRequiredFieldValidator2>")
	]
	public class SimpleRegexValidator2 : SimpleBaseValidator2
	{
		[
		Category("Behavior"),
		DefaultValue(""),
		Editor("System.Web.UI.Design.WebControls.RegexTypeEditor,System.Design", typeof(UITypeEditor)),
		]                                         
		public string ValidationExpression 
		{
			get 
			{ 
				object o = ViewState["ValidationExpression"];
				return((o == null) ? String.Empty : (string)o);
			}
			set 
			{
				try 
				{
					Regex.IsMatch("", value);
				}
				catch (Exception e) 
				{
					throw new HttpException("ǥ ߸ Ǿϴ.", e);
				}
				ViewState["ValidationExpression"] = value;
			}
		}

		protected override void AddAttributesToRender(HtmlTextWriter writer)
		{
			base.AddAttributesToRender(writer);
			if (RenderUplevel) 
			{
				writer.AddAttribute("evaluationfunction", "RegularExpressionValidatorEvaluateIsValid");
				if (ValidationExpression.Length > 0) 
				{
					writer.AddAttribute("validationexpression", ValidationExpression);
				}
			}
		} 

		protected override bool EvaluateIsValid() 
		{
			string controlValue = GetControlValidationValue(ControlToValidate);
			if (controlValue == null || controlValue.Length == 0) 
				return true;
	
			Match m = Regex.Match(controlValue, ValidationExpression);
			return(m.Success && m.Index == 0 && m.Length == controlValue.Length);
		}
	}
}
