using System;
using System.Collections;
using System.ComponentModel;
using System.Web;
using System.Security;
using System.Security.Principal;
using System.Web.Security;
using System.Data.SqlClient;

namespace PowerOfDotNet {

    public class Global : System.Web.HttpApplication {

        //*********************************************************************
        //
        // Application_BeginRequest Event
        //
        // The Application_BeginRequest method is an ASP.NET event that executes 
        // on each web request into the portal application.  The below method
        // obtains the current tabIndex and TabId from the querystring of the 
        // request -- and then obtains the configuration necessary to process
        // and render the request.
        //
        // This portal configuration is stored within the application's "Context"
        // object -- which is available to all pages, controls and components
        // during the processing of a single request.
        // 
        //*********************************************************************

        protected void Application_BeginRequest(Object sender, EventArgs e) {

			//new PortalSettings(tabId, pageid) ͺ̽  ʿϹǷ
			//  ʿ  bypass GET ĶŸ ѱ.
			if (Request.Params["bypass"] != null) return;
    
            int tabId = 0;
			int pageid = 0;

			//Request.QueryString["psup"]   ó ޵ȴ.
			// psup=tabid=1:pageid=0
			string strPAUP = Request.QueryString["psup"];
			try {
				if (strPAUP != null) {
					foreach (string parmPair in strPAUP.Split(new char[]{':'}))	{
						string[] aParm = parmPair.Split(new char[]{'='});
						//Ķ  Ʋ 
						if (aParm.Length != 2) continue;

						switch (aParm[0].ToLower()) {
							case "tabid" :
								tabId = Convert.ToInt32(aParm[1]);
								break;
							case "pageid" :
								pageid = Convert.ToInt32(aParm[1]);
								break;
						}
					}
				}
			}
			catch {
				tabId = 0;
				pageid = 0;
			}


			Context.Items.Add("PortalSettings", new PortalSettings(tabId, pageid));
        }
                          
        //*********************************************************************
        //
        // Application_AuthenticateRequest Event
        //
        // If the client is authenticated with the application, then determine
        // which security roles he/she belongs to and replace the "User" intrinsic
        // with a custom IPrincipal security object that permits "User.IsInRole"
        // role checks within the application
        //
        // Roles are cached in the browser in an in-memory encrypted cookie.  If the
        // cookie doesn't exist yet for this session, create it.
        //
        //*********************************************************************

		protected void Application_AuthenticateRequest(Object sender, EventArgs e) 
		{
			if (Request.IsAuthenticated == true) {
				String[] roles;
				UsersDB user = new UsersDB();

				//   ϴ Ű   Ѵ.
				if ((Request.Cookies["portalroles"] == null) || 
					(Request.Cookies["portalroles"].Value == "")) {
					//    ڿ 迭 ´.
					roles = user.GetRoles(User.Identity.Name);

					// Ű ϱ  ڿ 迭 ϳ ڿ ȯ
					String roleStr = "";
					foreach (String role in roles) {
						roleStr += role;
						roleStr += ";";
					}

					//      Ƽ 
					FormsAuthenticationTicket ticket = new FormsAuthenticationTicket(
						1,                              // version
						Context.User.Identity.Name,     // user name
						DateTime.Now,                   // issue time
						DateTime.Now.AddHours(1),       // expires every 1 hour
						false,                          // don't persist cookie
						roleStr                         // roles
						);

					// Ű Ŭ̾Ʈ Ǳ 
					//    Ƽ ȣȭѴ.
					String cookieStr = FormsAuthentication.Encrypt(ticket);

					// ȣȭ Ƽ Ű Ѵ.
					Response.Cookies["portalroles"].Value = cookieStr;
					Response.Cookies["portalroles"].Path = "/";
					Response.Cookies["portalroles"].Expires = DateTime.Now.AddMinutes(1);
				}
				else {
					// ȣȭؼ ڿ  Ű ߴ Ƽ
					// ٽ FormsAuthenticationTicket  ü .
					FormsAuthenticationTicket ticket = FormsAuthentication.Decrypt(Context.Request.Cookies["portalroles"].Value);

					ArrayList userRoles = new ArrayList();

					//GenericPrincipal ڿ ڷ ϱ 
					//  ϴ ڿ ڿ 迭 ȯѴ.
					foreach (String role in ticket.UserData.Split( new char[] {';'} )) {
						userRoles.Add(role);
					}

					roles = (String[]) userRoles.ToArray(typeof(String));
				}

				//    GenericPrincipal ü 
				Context.User = new GenericPrincipal(Context.User.Identity, roles);

				//  Ű Ѵ.
				if (Request.Cookies["usersInfo"] == null || 
					Request.Cookies["usersInfo"].Value == "") {
					SqlDataReader dr = user.GetSingleUser(Context.User.Identity.Name);
					dr.Read();
					//Expires    ִµ ȿϴ.
					Response.Cookies["usersInfo"]["Name"] = dr["Name"].ToString();
					Response.Cookies["usersInfo"]["UserDir"] = dr["UserDirectory"].ToString();
					Response.Cookies["usersInfo"]["OnceVisitedClubs"] = "";
					Response.Cookies["usersInfo"].Path = "/";
					dr.Close();
				}
			}
		}
    }
}

