using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Home.Admin
{
	/// <summary>
	/// EditFragBoard   Դϴ.
	/// </summary>
	public class EditFragBoard : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstFragBoardType;
		protected System.Web.UI.WebControls.CheckBox chkboxOpenWindowAtStart;
		protected System.Web.UI.WebControls.Button btnSave;
		protected System.Web.UI.WebControls.Button btnRemoveSetting;
		protected System.Web.UI.WebControls.DropDownList drpdnlstBoardSelect;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack) {
				drpdnlstBoardSelect.DataSource = CtrateBoareInfoList();
				drpdnlstBoardSelect.DataTextField = "BBSSubject";
				drpdnlstBoardSelect.DataValueField = "BBSID";
				drpdnlstBoardSelect.DataBind();

				int moduleId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.QueryString["mId"], -1);

				Components.BoardLactureDB db = new Components.BoardLactureDB();
				SqlDataReader dr = db.GetFragBoardSetting(moduleId);
				if (dr.Read()) {
					int fragBoardType = (int)(byte)dr["fragBoardType"];

					rdobtnlstFragBoardType.SelectedIndex = fragBoardType;
					chkboxOpenWindowAtStart.Checked = (bool)dr["openWindowAtStart"];
					drpdnlstBoardSelect.Items.FindByValue(dr["bbsId"].ToString()).Selected = true;
				}
				else {
					rdobtnlstFragBoardType.SelectedIndex = 0;
				}
			}
		}

		private ICollection CtrateBoareInfoList()
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("BBSID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("BBSSubject", typeof(string)));

			Components.BoardLactureDB db = new Components.BoardLactureDB();
			SqlDataReader sdr = db.GetBoardAllInfo();

			while (sdr.Read()) {
				dr = dt.NewRow();

				dr[0] = sdr["BBSID"];
				dr[1] = sdr["BBSSubject"];

				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);
			return dv;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			this.btnRemoveSetting.Click += new System.EventHandler(this.btnRemoveSetting_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			int moduleId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.QueryString["mId"], -1);
			string cacheKey = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.QueryString["mcKey"], "");
			int bbsId = int.Parse(drpdnlstBoardSelect.SelectedItem.Value);

			Components.BoardLactureDB db = new Components.BoardLactureDB();
			db.SaveFragBoardSetting(moduleId, bbsId,
				(byte)rdobtnlstFragBoardType.SelectedIndex, 
				chkboxOpenWindowAtStart.Checked);

			Page.Cache.Remove(cacheKey);
			Response.Redirect("/");
		}

		private void btnRemoveSetting_Click(object sender, System.EventArgs e)
		{
			int moduleId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.QueryString["mId"], -1);
			string cacheKey = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.QueryString["mcKey"], "");

			Components.BoardLactureDB db = new Components.BoardLactureDB();
			db.RemoveFragBoardSetting(moduleId);

			Page.Cache.Remove(cacheKey);
		}
	}
}
