using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Configuration;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Text;
using System.Drawing.Drawing2D;
using System.IO;

using MyWebLibs.Utilities;

namespace PowerOfDotNet.Shop
{
	/// <summary>
	/// Shop ϴ ƿƼ ޼ҵ 
	/// </summary>
	public class ShopMethods
	{
		//IDataRecord ڸ ޾  ̹ ̸ Ѵ.
		static public string GetImageSNameByIDataRecord(IDataRecord drv)
		{
			string strNum = "0000" + drv["ID"].ToString();
			strNum = strNum.Substring(strNum.Length-5);
			string strHead = "ProdImg";

			return strHead + "S_" + strNum + GetImageNameStrByDataRecord(drv, strHead, strNum, "gif") + ".gif";
		}

		//DataRowView ڸ ޾  ̹ ̸ Ѵ.
		static public string GetImageSNameByDataRowView(DataRowView drv)
		{
			string strNum = "0000" + drv["ID"].ToString();
			strNum = strNum.Substring(strNum.Length-5);
			string strHead = "ProdImg";

			return strHead + "S_" + strNum + GetImageNameStrByDataRowView(drv, strHead, strNum, "gif") + ".gif";
		}

		//IDataRecord ڸ ޾  ̹ ̸ Ѵ.
		static public string GetImageMNameByIDataRecord(IDataRecord drv)
		{
			string strNum = "0000" + drv["ID"].ToString();
			strNum = strNum.Substring(strNum.Length-5);
			string strHead = "ProdImg";

			return strHead + "M_" + strNum + GetImageNameStrByDataRecord(drv, strHead, strNum, "gif") + ".gif";
		}

		//DataRowView ڸ ޾  ̹ ̸ Ѵ.
		static public string GetImageMNameByDataRowView(DataRowView drv)
		{
			string strNum = "0000" + drv["ID"].ToString();
			strNum = strNum.Substring(strNum.Length-5);
			string strHead = "ProdImg";

			return strHead + "M_" + strNum + GetImageNameStrByDataRowView(drv, strHead, strNum, "gif") + ".gif";
		}

		//ù° ڷ DataRowView ڸ ޾ ̹ ̸ ޺κ Ѵ.
		static private string GetImageNameStrByDataRowView(DataRowView drv, string imgNameHead, string imgNameNum, string imageNameExt)
		{
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			ArrayList aBests = (ArrayList)CommonMethods.GetObjectFromCache("ShopBest");
			if (aBests == null)
			{
				aBests = new ArrayList();
				SqlDataReader dr = db.GetBestProdectList();
				while (dr.Read())	aBests.Add((int)dr["ID"]);
				dr.Close();

				CommonMethods.SetObjectToCache("ShopBest",aBests,10);
			}

			//S-Sale, B-Best, R-õǰ
			string sPriority = ConfigurationSettings.AppSettings["ShopImageSelectPriority"];
			string[] aPriority = sPriority.Split(new char[] {','});
			
			if (aPriority.Length != 3)
				throw new Exception("Web.Config  <appSettings> ǿ ShopImageSelectPriority  ǰ ùٸ ʽϴ.");
			
			ArrayList aProdImages = new ArrayList();
			int id = (int)drv["ID"];
			int dcPercent = (int)drv["DiscountPercent"];

			if (aBests.IndexOf(id) > -1) aProdImages.Add("B");
			if (dcPercent > 0) aProdImages.Add("S");
			if ((byte)drv["Recommendation"] > 0) aProdImages.Add("R");

			if (aProdImages.Count > 0) {
				foreach (string kind in aPriority)
					if (aProdImages.IndexOf(kind) > -1)	{
						string imageTail = String.Empty;
						switch (kind) {
							case "S" :
								if (!(bool)drv["SaleImageGenerated"]) {
									if (GenerateSaleImage(dcPercent.ToString(), imgNameHead, imgNameNum, imageNameExt, ref imageTail))
										db.UpdateAltercastGenerated(id, kind, imageTail);
									else
										return String.Empty;
								}
								else
									imageTail = drv["SaleImageTail"].ToString().TrimEnd();

								break;
							case "B" :
								if (!(bool)drv["BestImageGenerated"]) {
									if (GenerateBestOrRecomImage("B",imgNameHead, imgNameNum, imageNameExt, ref imageTail))
										db.UpdateAltercastGenerated(id, kind, imageTail);
									else
										return String.Empty;
								}
								else
									imageTail = drv["BestImageTail"].ToString().TrimEnd();

								break;
							case "R" :
								if (!(bool)drv["RecomImageGenerated"]) {
									if (GenerateBestOrRecomImage("R", imgNameHead, imgNameNum, imageNameExt, ref imageTail))
										db.UpdateAltercastGenerated(id, kind, imageTail);
									else
										return String.Empty;
								}
								else
									imageTail = drv["RecomImageTail"].ToString().TrimEnd();

								break;
						}
						return kind + imageTail;
					}

					throw new Exception("Web.Config  <appSettings> ǿ ShopImageSelectPriority  ǰ ùٸ ʽϴ.");
			}
			else
				return String.Empty;
		}

		//ù° ڷ IDataRecord ڸ ޾ ̹ ̸ ޺κ Ѵ.
		static private string GetImageNameStrByDataRecord(IDataRecord drv, string imgNameHead, string imgNameNum, string imageNameExt)
		{
			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			ArrayList aBests = (ArrayList)CommonMethods.GetObjectFromCache("ShopBest");
			if (aBests == null) {
				aBests = new ArrayList();
				SqlDataReader dr = db.GetBestProdectList();
				while (dr.Read())	aBests.Add((int)dr["ID"]);
				dr.Close();

				CommonMethods.SetObjectToCache("ShopBest",aBests,10);
			}

			//S-Sale, B-Best, R-õǰ
			string sPriority = ConfigurationSettings.AppSettings["ShopImageSelectPriority"];
			string[] aPriority = sPriority.Split(new char[] {','});
			
			if (aPriority.Length != 3)
				throw new Exception("Web.Config  <appSettings> ǿ ShopImageSelectPriority  ǰ ùٸ ʽϴ.");
			
			ArrayList aProdImages = new ArrayList();
			int id = (int)drv["ID"];
			int dcPercent = (int)drv["DiscountPercent"];

			if (aBests.IndexOf(id) > -1) aProdImages.Add("B");
			if (dcPercent > 0) aProdImages.Add("S");
			if ((byte)drv["Recommendation"] > 0) aProdImages.Add("R");

			if (aProdImages.Count > 0) 
				{//켱     óȴ.
				foreach (string kind in aPriority)
					if (aProdImages.IndexOf(kind) > -1) {
						string imageTail = String.Empty;
						switch (kind) {
							case "S" :
								if (!(bool)drv["SaleImageGenerated"]) {
									if (GenerateSaleImage(dcPercent.ToString(), imgNameHead, imgNameNum, imageNameExt, ref imageTail))
										db.UpdateAltercastGenerated(id, kind, imageTail);
									else
										return String.Empty;
								}
								else
									imageTail = drv["SaleImageTail"].ToString().TrimEnd();

								break;
							case "B" :
								if (!(bool)drv["BestImageGenerated"]) {
									if (GenerateBestOrRecomImage("B", imgNameHead, imgNameNum, imageNameExt, ref imageTail))
										db.UpdateAltercastGenerated(id, kind, imageTail);
									else
										return String.Empty;
								}
								else
									imageTail = drv["BestImageTail"].ToString().TrimEnd();

								break;
							case "R" :
								if (!(bool)drv["RecomImageGenerated"]) {
									if (GenerateBestOrRecomImage("R", imgNameHead, imgNameNum, imageNameExt, ref imageTail))
										db.UpdateAltercastGenerated(id, kind, imageTail);
									else
										return String.Empty;
								}
								else
									imageTail = drv["RecomImageTail"].ToString().TrimEnd();

								break;
						}
						return kind + imageTail;
					}

				throw new Exception("Web.Config  <appSettings> ǿ ShopImageSelectPriority  ǰ ùٸ ʽϴ.");
			}
			else
				return String.Empty;
		}

		// ɽƮ ̹ Ѵ.
		static private bool GenerateSaleImage(string percentStr, string imgNameHead, string imgNameNum, string imageNameExt, ref string imageTail)
		{
			string appendString;
			int stringPlace;
			string stringColor;
			string stringFont;
			int stringSize;
			string overImage;
			int[] overXY = new int[2];
			int overRotate;
			int overAlpha;
			int overPercent;
			int[] overStringPosXY = new int[2];
			bool overStringHAuto;
			bool overStringVAuto;
			int originalSize;

			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			SqlDataReader dr = db.GetAltercastImageInfo("S");

			if (dr.Read()) {
				appendString = dr["appendString"].ToString();
				stringPlace = (int)dr["stringPlace"];
				stringColor = dr["stringColor"].ToString();
				stringFont = dr["stringFont"].ToString();
				stringSize = (int)dr["stringSize"];
				overImage = dr["overImage"].ToString();
				overXY[0] = (int)dr["overCoordX"];
				overXY[1] = (int)dr["overCoordY"];
				overRotate = (int)dr["overRotate"];
				overAlpha = (int)dr["overAlpha"];
				overPercent = (int)dr["overPercent"];
				overStringPosXY[0] = (int)dr["overStringPosX"];
				overStringPosXY[1] = (int)dr["overStringPosY"];
				overStringHAuto = (bool)dr["overStringHAuto"];
				overStringVAuto = (bool)dr["overStringVAuto"];
				originalSize = (int)dr["originalSize"];
			}
			else
				return false;

			HttpContext context = HttpContext.Current;
			string[] aOrgImages = new String[2];
			aOrgImages[0] = imgNameHead + "M_" + imgNameNum;
			aOrgImages[1] = imgNameHead + "S_" + imgNameNum;

			try {
				imageTail = DateTime.Now.Ticks.ToString();

				foreach (string orgImageName in aOrgImages)	{
					Bitmap oBaseImage = new Bitmap(context.Request.MapPath("/shop/Images/Products/" + orgImageName + ".jpg"));
					Graphics oGraphics = Graphics.FromImage( oBaseImage );

					//GraphicsContainer oGraphicsContainer = oGraphics.BeginContainer();

					float scaleValue1 = (float)oBaseImage.Width / (float)originalSize;
					oGraphics.ScaleTransform(scaleValue1, scaleValue1);

					float scaleValue2 = (float)overPercent / 100;
					oGraphics.ScaleTransform(scaleValue2, scaleValue2, MatrixOrder.Append);


					int coordinateX = (int)(overXY[0] * scaleValue1);
					int coordinateY = (int)(overXY[1] * scaleValue1);

					oGraphics.TranslateTransform(coordinateX, coordinateY, MatrixOrder.Append);

					// Create an ImageAttributes object and set the color matrix.
					ColorMatrix myColorMatrix = new ColorMatrix();
					myColorMatrix.Matrix00 = 1.00f; // Red
					myColorMatrix.Matrix11 = 1.00f; // Green
					myColorMatrix.Matrix22 = 1.00f; // Blue
					myColorMatrix.Matrix33 = ((float)overAlpha / 100); // alpha
					myColorMatrix.Matrix44 = 1.00f; // w

					ImageAttributes imageAttr = new ImageAttributes();
					imageAttr.SetColorMatrix(myColorMatrix);

					Color lowerColor = Color.FromArgb(255,255,255);
					Color upperColor = Color.FromArgb(255,255,255);
					imageAttr.SetColorKey(lowerColor, upperColor);

					Bitmap oOverImage = new Bitmap(context.Request.MapPath("/shop/Images/Sale/" + overImage));

					oGraphics.RotateTransform(overRotate);

					oGraphics.CompositingMode = CompositingMode.SourceOver;
					Rectangle rectImg = new Rectangle(0, 0, oOverImage.Width, oOverImage.Height);
					oGraphics.DrawImage(oOverImage,         // Image
						rectImg,            // Dest. rect.
						0,               // srcX
						0,               // srcY
						oOverImage.Width,             // srcWidth
						oOverImage.Height,             // srcHeight
						GraphicsUnit.Pixel, // srcUnit
						imageAttr);      // ImageAttributes

					FontFamily fontFamily = new FontFamily(stringFont);
					Font font = new Font(
						fontFamily,
						stringSize, FontStyle.Bold,
						GraphicsUnit.Pixel);

					StringFormat stringFormat = new StringFormat();
					int rectStrX = 0;
					int rectStrY = 0;
					if (overStringPosXY[0] != -1 && !overStringHAuto)
						rectStrX = overStringPosXY[0];
					else // Center each line of text.
						stringFormat.Alignment = StringAlignment.Center;

					if (overStringPosXY[1] != -1 && !overStringVAuto)
						rectStrY = overStringPosXY[1];
					else // Center the block of text (top to bottom) in the rectangle.
						stringFormat.LineAlignment = StringAlignment.Center;

					Rectangle rectStr = new Rectangle(rectStrX, rectStrY, oOverImage.Width, oOverImage.Height);
					SolidBrush solidBrush = new SolidBrush(Color.FromName(stringColor));

					string text = stringPlace == 1 ? appendString + percentStr : percentStr + appendString;
					oGraphics.DrawString(text, font, solidBrush, rectStr, stringFormat);

					//oGraphics.EndContainer(oGraphicsContainer);

					string filePath = context.Server.MapPath("/Shop/Images/Products/");
					// ִ  ĳƮ ̹  .
					string [] files = Directory.GetFiles(filePath, orgImageName + "S*" + ".gif");
					foreach (string file in files)
						File.Delete(file);
					//ɽƮ ̹ Ѵ.
					oBaseImage.Save(filePath + orgImageName + "S" + 
						imageTail + "." + imageNameExt, ImageFormat.Gif);
			
					oOverImage.Dispose();
					oGraphics.Dispose();
					oBaseImage.Dispose();
				}

				return true;
			}
			catch {
				return false;
			}
		}

		static private bool GenerateBestOrRecomImage(string kind, string imgNameHead, string imgNameNum, string imageNameExt, ref string imageTail)
		{
			string overImage;
			int[] overXY = new int[2];
			int overRotate;
			int overAlpha;
			int overPercent;
			int[] overStringPosXY = new int[2];
			int originalSize;

			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			SqlDataReader dr = db.GetAltercastImageInfo(kind);

			if (dr.Read())
			{
				overImage = dr["overImage"].ToString();
				overXY[0] = (int)dr["overCoordX"];
				overXY[1] = (int)dr["overCoordY"];
				overRotate = (int)dr["overRotate"];
				overAlpha = (int)dr["overAlpha"];
				overPercent = (int)dr["overPercent"];
				overStringPosXY[0] = (int)dr["overStringPosX"];
				overStringPosXY[1] = (int)dr["overStringPosY"];
				originalSize = (int)dr["originalSize"];
			}
			else
				return false;

			HttpContext context = HttpContext.Current;
			string[] aOrgImages = new String[2];
			aOrgImages[0] = imgNameHead + "M_" + imgNameNum;
			aOrgImages[1] = imgNameHead + "S_" + imgNameNum;

			try {
				imageTail = DateTime.Now.Ticks.ToString();

				foreach (string orgImageName in aOrgImages)
				{
					Bitmap oBaseImage = new Bitmap(context.Request.MapPath("/shop/Images/Products/" + orgImageName + ".jpg"));
					Graphics oGraphics = Graphics.FromImage( oBaseImage );

					//GraphicsContainer oGraphicsContainer = oGraphics.BeginContainer();

					float scaleValue1 = (float)oBaseImage.Width / (float)originalSize;
					oGraphics.ScaleTransform(scaleValue1, scaleValue1);

					float scaleValue2 = (float)overPercent / 100;
					oGraphics.ScaleTransform(scaleValue2, scaleValue2, MatrixOrder.Append);


					int coordinateX = (int)(overXY[0] * scaleValue1);
					int coordinateY = (int)(overXY[1] * scaleValue1);

					oGraphics.TranslateTransform(coordinateX, coordinateY, MatrixOrder.Append);

					// Create an ImageAttributes object and set the color matrix.
					ColorMatrix myColorMatrix = new ColorMatrix();
					myColorMatrix.Matrix00 = 1.00f; // Red
					myColorMatrix.Matrix11 = 1.00f; // Green
					myColorMatrix.Matrix22 = 1.00f; // Blue
					myColorMatrix.Matrix33 = ((float)overAlpha / 100); // alpha
					myColorMatrix.Matrix44 = 1.00f; // w

					// Create an ImageAttributes object and set the color matrix.
					ImageAttributes imageAttr = new ImageAttributes();
					imageAttr.SetColorMatrix(myColorMatrix);

					Color lowerColor = Color.FromArgb(255,255,255);
					Color upperColor = Color.FromArgb(255,255,255);
					imageAttr.SetColorKey(lowerColor, upperColor);

					Bitmap oOverImage;
					if(kind == "B")
						oOverImage = new Bitmap(context.Request.MapPath("/shop/Images/Best/" + overImage));
					else
						oOverImage = new Bitmap(context.Request.MapPath("/shop/Images/Recom/" + overImage));

					oGraphics.RotateTransform(overRotate);

					oGraphics.CompositingMode = CompositingMode.SourceOver;
					Rectangle rectImg = new Rectangle(0, 0, oOverImage.Width, oOverImage.Height);
					oGraphics.DrawImage(oOverImage,         // Image
						rectImg,            // Dest. rect.
						0,               // srcX
						0,               // srcY
						oOverImage.Width,             // srcWidth
						oOverImage.Height,             // srcHeight
						GraphicsUnit.Pixel, // srcUnit
						imageAttr);      // ImageAttributes

					//oGraphics.EndContainer(oGraphicsContainer);

					string filePath = context.Server.MapPath("/Shop/Images/Products/");
					string [] files = Directory.GetFiles(filePath, orgImageName + kind + "*" + ".gif");
					foreach (string file in files)
						File.Delete(file);

					oBaseImage.Save(filePath + orgImageName + kind + 
						imageTail + "." + imageNameExt, ImageFormat.Gif);
			
					oOverImage.Dispose();
					oGraphics.Dispose();
					oBaseImage.Dispose();
				}
				return true;
			}
			catch 
			{
				return false;
			}
		}

		static public void CreatePager(Control ocDest,int CurPage, int RowCount, int PageSize, int ListSize, string strUrl, string strPage)
		{
			int LSP = (int)(CurPage / ListSize + 1);
			int startpage = (LSP - 1) * ListSize + 1;
			int endpage = LSP * ListSize;
			int np;
			int intPageCnt = (int)((RowCount-1)/PageSize) + 1;
			Literal litlChar;
			HyperLink hlnkPage;
			string strSeparator;

			//ּҾȿ ?ִĿ ڰ Ʋ.
			if (strUrl.IndexOf("?") == -1) strSeparator = "?";
			else strSeparator = "&";

			//  պκ
			if (startpage > 1)
			{
				litlChar = new Literal();
				litlChar.Text = "[";
				ocDest.Controls.Add(litlChar);

				hlnkPage = new HyperLink();
				hlnkPage.Text = "1";
				hlnkPage.NavigateUrl = strUrl + strSeparator + strPage + "=0";
				ocDest.Controls.Add(hlnkPage);

				litlChar = new Literal();
				litlChar.Text = "]";
				ocDest.Controls.Add(litlChar);

				litlChar = new Literal();
				litlChar.Text = "&nbsp;";
				ocDest.Controls.Add(litlChar);

				np = startpage - 1;
				litlChar = new Literal();
				litlChar.Text = "[";
				ocDest.Controls.Add(litlChar);

				hlnkPage = new HyperLink();
				hlnkPage.Text = "<font color=\"red\"></font>";
				hlnkPage.NavigateUrl = strUrl + strSeparator + strPage + "=" + np.ToString();
				ocDest.Controls.Add(hlnkPage);

				litlChar = new Literal();
				litlChar.Text = "]";
				ocDest.Controls.Add(litlChar);

				litlChar = new Literal();
				litlChar.Text = "&nbsp;&nbsp;";
				ocDest.Controls.Add(litlChar);
			} 
			else 
			{

			}

			if (endpage > intPageCnt) endpage = intPageCnt;
			for (int i=startpage; i<=endpage; i++)
			{

				if (i != (CurPage + 1)) 
				{
					litlChar = new Literal();
					litlChar.Text = "[";
					ocDest.Controls.Add(litlChar);

					hlnkPage = new HyperLink();
					hlnkPage.Text = i.ToString();
					hlnkPage.NavigateUrl = strUrl + strSeparator + strPage + "=" + (i-1).ToString();
					ocDest.Controls.Add(hlnkPage);

					litlChar = new Literal();
					litlChar.Text = "]";
					ocDest.Controls.Add(litlChar);
				}
				else
				{
					litlChar = new Literal();
					litlChar.Text = "<b>[" + i.ToString() + "]</b>";
					ocDest.Controls.Add(litlChar);
				}
			}
			
			if (endpage < intPageCnt)
			{

				litlChar = new Literal();
				litlChar.Text = "&nbsp;&nbsp;";
				ocDest.Controls.Add(litlChar);
				
				//np = endpage + 1;
				np = endpage;
				litlChar = new Literal();
				litlChar.Text = "[";
				ocDest.Controls.Add(litlChar);

				hlnkPage = new HyperLink();
				hlnkPage.Text = "<font color=\"red\"></font>";
				hlnkPage.NavigateUrl = strUrl + strSeparator + strPage + "=" + np.ToString();
				ocDest.Controls.Add(hlnkPage);

				litlChar = new Literal();
				litlChar.Text = "]";
				ocDest.Controls.Add(litlChar);

				litlChar = new Literal();
				litlChar.Text = "&nbsp;";
				ocDest.Controls.Add(litlChar);


				litlChar = new Literal();
				litlChar.Text = "[";
				ocDest.Controls.Add(litlChar);

				hlnkPage = new HyperLink();
				hlnkPage.Text = intPageCnt.ToString();
				hlnkPage.NavigateUrl = strUrl + strSeparator + strPage + "=" + (intPageCnt-1).ToString();
				ocDest.Controls.Add(hlnkPage);

				litlChar = new Literal();
				litlChar.Text = "]";
				ocDest.Controls.Add(litlChar);
			} 
			else 
			{

			}
			
		}
	}
}
