using System;
using System.Collections;
using System.Diagnostics;
using System.Configuration;
using System.Xml;
using System.Collections.Specialized;

namespace MyWebLibs.Altercast
{
	/// <summary>
	/// AltercastConfiguration   Դϴ.
	/// </summary>
	public class AltercastConfiguration : IConfigurationSectionHandler
	{

		public struct ConfigInfo {
			public string BaseDir;
			public string ImageNameHead;
			public string AltercastDirName;
			public string ImageFormatL;
			public string ImageFormatM;
			public string ImageFormatS;
			public ArrayList Kinds;
		}

		public object Create(object parent, object configContext, XmlNode section)
		{
			Hashtable configInfos = new Hashtable();

			foreach( XmlNode node in section.ChildNodes ) {
				if (node.Name == "defination") {

					ConfigInfo ci = new ConfigInfo();

					ci.BaseDir = node.Attributes["base-dir"].Value;
					ci.ImageNameHead = node.Attributes["image-name-head"].Value;
					ci.AltercastDirName = node.Attributes["altercast-dir-name"].Value;

					//⺻ 
					ci.ImageFormatL = "gif";
					ci.ImageFormatM = "gif";
					ci.ImageFormatS = "gif";

					foreach( XmlNode sNode in node.ChildNodes) {
						if (sNode.Name == "kind") {
							ci.Kinds = new ArrayList();
							foreach( XmlNode kNode in sNode.ChildNodes) 
								if (kNode.Name == "add") {
									Kind k = new Kind();
									k.Nmae = kNode.Attributes["name"].Value;
									k.Simpler = kNode.Attributes["simpler"].Value;
									
									ci.Kinds.Add(k);
								}
						}
						else if (sNode.Name == "imageFormat") {
							ci.ImageFormatL = sNode.Attributes["large"].Value;
							ci.ImageFormatM = sNode.Attributes["middle"].Value;
							ci.ImageFormatS = sNode.Attributes["small"].Value;
						}
					}

					configInfos[node.Attributes["name"].Value] = ci;
				}
			}

			return configInfos;
		}

	}
}
