/*
 * 2004 2 20 
 * */


namespace PowerOfDotNet.admin
{
	using System;
	using System.Collections;
	using System.ComponentModel;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.SessionState;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Data.SqlClient;
	using PowerOfDotNet.Components;

	/// <summary>
	///		TabLayout   Դϴ.
	/// </summary>
	public abstract class TabLayout : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox tabName;
		protected System.Web.UI.WebControls.TextBox templateFileName;
		protected System.Web.UI.WebControls.CheckBox showMobile;
		protected System.Web.UI.WebControls.TextBox mobileTabName;
		protected System.Web.UI.WebControls.DropDownList moduleType;
		protected System.Web.UI.WebControls.TextBox moduleTitle;
		protected System.Web.UI.WebControls.LinkButton AddModuleBtn;
		protected System.Web.UI.WebControls.ListBox leftPane;
		protected System.Web.UI.WebControls.ImageButton LeftUpBtn;
		protected System.Web.UI.WebControls.ImageButton LeftRightBtn;
		protected System.Web.UI.WebControls.ImageButton LeftDownBtn;
		protected System.Web.UI.WebControls.ImageButton LeftEditBtn;
		protected System.Web.UI.WebControls.ImageButton LeftDeleteBtn;
		protected System.Web.UI.WebControls.ListBox contentPane;
		protected System.Web.UI.WebControls.ImageButton ContentUpBtn;
		protected System.Web.UI.WebControls.ImageButton ContentLeftBtn;
		protected System.Web.UI.WebControls.ImageButton ContentRightBtn;
		protected System.Web.UI.WebControls.ImageButton ContentDownBtn;
		protected System.Web.UI.WebControls.ImageButton ContentEditBtn;
		protected System.Web.UI.WebControls.ImageButton ContentDeleteBtn;
		protected System.Web.UI.WebControls.ImageButton RightUpBtn;
		protected System.Web.UI.WebControls.ImageButton RightLeftBtn;
		protected System.Web.UI.WebControls.ImageButton RightDownBtn;
		protected System.Web.UI.WebControls.ImageButton RightEditBtn;
		protected System.Web.UI.WebControls.ImageButton RightDeleteBtn;
		protected System.Web.UI.WebControls.LinkButton applyBtn;

		int tabId;
		//int pageId;
		protected ArrayList leftList;
		protected ArrayList contentList;
		protected System.Web.UI.WebControls.PlaceHolder placehdrPageSetup;
		protected System.Web.UI.WebControls.TextBox txtPageName;
		protected System.Web.UI.WebControls.TextBox txtPageTemplate;
		protected System.Web.UI.WebControls.ImageButton imgbtnPageDelete;
		protected System.Web.UI.WebControls.ListBox lstboxPages;
		protected System.Web.UI.HtmlControls.HtmlTableCell TD1;
		protected System.Web.UI.WebControls.Label lblPageMessage;
		protected System.Web.UI.WebControls.LinkButton lnkbtnPageUpdate;
		protected System.Web.UI.WebControls.ImageButton imgbtnPageAdd;
		protected System.Web.UI.WebControls.ImageButton imgbtnPageSelect;
		protected System.Web.UI.WebControls.HyperLink hyplnkToAdminMain;
		protected System.Web.UI.WebControls.PlaceHolder placehdrModuleSetup;
		protected System.Web.UI.WebControls.CheckBoxList tabAuthRoles;
		protected System.Web.UI.WebControls.CheckBoxList pageAuthRoles;
		protected System.Web.UI.WebControls.ListBox RightPane;
		protected ArrayList rightList;

		//*******************************************************
		//
		// The Page_Load server event handler on this page is used
		// to populate a tab's layout settings on the page
		//
		//*******************************************************

		private void Page_Load(object sender, System.EventArgs e) 
		{

			// Verify that the current user has access to access this page
			if (PortalSecurity.IsInRoles("Admins") == false) 
			{
				Response.Redirect("~/Admin/EditAccessDenied.aspx");
			}

			tabId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["tabid"], 0);
			//pageId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["pageid"], -1);

			// If first visit to the page, update all entries
			if (Page.IsPostBack == false) 
			{
				BindData();
				ViewState["pageid"] = -1;
				hyplnkToAdminMain.NavigateUrl = GetLink("");
			}
		}

		//*******************************************************
		//
		// The AddModuleToPane_Click server event handler on this page is used
		// to add a new portal module into the tab
		//
		//*******************************************************

		private void AddModuleToPane_Click(Object sender, EventArgs e) 
		{

			// All new modules go to the end of the contentpane
			ModuleItem m = new ModuleItem();
			m.ModuleTitle = moduleTitle.Text;
			m.ModuleDefId = Int32.Parse(moduleType.SelectedItem.Value);
			m.ModuleOrder = 999;
        
			int pageId = Convert.ToInt32(ViewState["pageid"]);
			// save to database
			AdminDB admin = new AdminDB();
			m.ModuleId = admin.AddModule(tabId, pageId, m.ModuleOrder, "ContentPane", m.ModuleTitle, m.ModuleDefId, 0, "", "Admins", false);
        
			// reorder the modules in the content pane
			ArrayList modules = GetModules("ContentPane");
			OrderModules(modules);
        
			// resave the order
			foreach (ModuleItem item in modules)
			{
				admin.UpdateModuleOrder(item.ModuleId, item.ModuleOrder, "ContentPane");
			}

			ModulePaneBind();
		}

		//*******************************************************
		//
		// The UpDown_Click server event handler on this page is
		// used to move a portal module up or down on a tab's layout pane
		//
		//*******************************************************

		private void UpDown_Click(Object sender, ImageClickEventArgs e) 
		{

			String cmd = ((ImageButton)sender).CommandName;
			String pane = ((ImageButton)sender).CommandArgument;
			//ListBox _listbox = (ListBox) Page.FindControl(pane);
			ListBox _listbox = (ListBox) placehdrModuleSetup.FindControl(pane);
               
			ArrayList modules = GetModules(pane);
        
			if (_listbox.SelectedIndex != -1) 
			{

				int delta;
				int selection = -1; 
            
				// Determine the delta to apply in the order number for the module
				// within the list.  +3 moves down one item; -3 moves up one item
            
				if (cmd == "down") 
				{
            
					delta = 3;
					if (_listbox.SelectedIndex < _listbox.Items.Count-1)
						selection = _listbox.SelectedIndex + 1;
				}
				else 
				{
            
					delta = -3;
					if (_listbox.SelectedIndex > 0)
						selection = _listbox.SelectedIndex - 1;
				}

				ModuleItem m;
				m = (ModuleItem) modules[_listbox.SelectedIndex];
				m.ModuleOrder += delta; 
            
				// reorder the modules in the content pane
				OrderModules(modules);
        
				// resave the order
				AdminDB admin = new AdminDB();
				foreach (ModuleItem item in modules) 
				{
					admin.UpdateModuleOrder(item.ModuleId, item.ModuleOrder, pane);
				}

				//ĳÿ    
				PortalUtil.ResetCachedPortalSettingData();
			}

			ModulePaneBind();
		}

		//*******************************************************
		//
		// The RightLeft_Click server event handler on this page is
		// used to move a portal module between layout panes on
		// the tab page
		//
		//*******************************************************

		private void RightLeft_Click(Object sender, ImageClickEventArgs e) 
		{

			String sourcePane = ((ImageButton)sender).Attributes["sourcepane"];
			String targetPane = ((ImageButton)sender).Attributes["targetpane"];
			//ListBox sourceBox = (ListBox) Page.FindControl(sourcePane);
			//ListBox targetBox = (ListBox) Page.FindControl(targetPane);
			ListBox sourceBox = (ListBox) placehdrModuleSetup.FindControl(sourcePane);
			ListBox targetBox = (ListBox) placehdrModuleSetup.FindControl(targetPane);
			
         
			if (sourceBox.SelectedIndex != -1) 
			{

				// get source arraylist
				ArrayList sourceList = GetModules(sourcePane);
        
				// get a reference to the module to move
				// and assign a high order number to send it to the end of the target list
				ModuleItem m = (ModuleItem) sourceList[sourceBox.SelectedIndex];
            
				// add it to the database
				AdminDB admin = new AdminDB();
				admin.UpdateModuleOrder(m.ModuleId, 998, targetPane);

				// delete it from the source list
				sourceList.RemoveAt(sourceBox.SelectedIndex);

				// reorder the modules in the source pane
				sourceList = GetModules(sourcePane);
				OrderModules(sourceList);
            
				// resave the order
				foreach (ModuleItem item in sourceList) 
				{
					admin.UpdateModuleOrder(item.ModuleId, item.ModuleOrder, sourcePane);
				}           
            
				// reorder the modules in the target pane
				ArrayList targetList = GetModules(targetPane);
				OrderModules(targetList);
                        
				// resave the order
				foreach (ModuleItem item in targetList) 
				{
					admin.UpdateModuleOrder(item.ModuleId, item.ModuleOrder, targetPane);
				}           
            
				ModulePaneBind();

				//ĳÿ    
				PortalUtil.ResetCachedPortalSettingData();
			}
		}

		//*******************************************************
		//
		// The Apply_Click server event handler on this page is
		// used to save the current tab settings to the database and 
		// then redirect back to the main admin page.
		//
		//*******************************************************

		private void Apply_Click(Object Sender, EventArgs e) 
		{
			SaveTabData();
		}

		//*******************************************************
		//
		// The PageSettings_Change server event handler on this page is
		// invoked any time the tab name or access security settings
		// change.  The event handler in turn calls the "SaveTabData"
		// helper method to ensure that these changes are persisted
		// to the portal configuration file.
		//
		//*******************************************************

		private void PageSettings_Change(Object sender, EventArgs e) 
		{

			// Ensure that settings are saved
			SaveTabData();
		}

		//*******************************************************
		//
		// The SaveTabData helper method is used to persist the
		// current tab settings to the database.
		//
		//*******************************************************

		private void SaveTabData() 
		{
			// Construct Authorized User Roles String
			String authorizedRoles = "";

			foreach(ListItem item in tabAuthRoles.Items) 
			{
				if (item.Selected == true) 
				{
					authorizedRoles = authorizedRoles + item.Text + ";";
				}
			}
        
			// Obtain PortalSettings from Current Context
			PortalSettings portalSettings = (PortalSettings) Context.Items["PortalSettings"];

			// update Tab info in the database
			AdminDB admin = new AdminDB();
			admin.UpdateTab(portalSettings.PortalId, tabId, tabName.Text, Convert.ToInt32(ViewState["TabOrder"]), authorizedRoles, mobileTabName.Text, showMobile.Checked);

			//ĳÿ    
			PortalUtil.ResetCachedPortalSettingData();
		}
    
		//*******************************************************
		//
		// The EditBtn_Click server event handler on this page is
		// used to edit an individual portal module's settings
		//
		//*******************************************************

		private void EditBtn_Click(Object sender, ImageClickEventArgs e) 
		{

			String pane = ((ImageButton)sender).CommandArgument;
			//ListBox _listbox = (ListBox) Page.FindControl(pane);
			ListBox _listbox = (ListBox) placehdrModuleSetup.FindControl(pane);

			if (_listbox.SelectedIndex != -1) 
			{

				int mid = Int32.Parse(_listbox.SelectedItem.Value);
            
				// Redirect to module settings page
				Response.Redirect(GetLink("-⼳") + "&mid=" + mid + "&tabid=" + tabId);
			}
		}

		//*******************************************************
		//
		// The DeleteBtn_Click server event handler on this page is
		// used to delete an portal module from the page
		//
		//*******************************************************

		private void DeleteBtn_Click(Object sender, ImageClickEventArgs e) 
		{

			String pane = ((ImageButton)sender).CommandArgument;
			//ListBox _listbox = (ListBox) Page.FindControl(pane);
			ListBox _listbox = (ListBox) placehdrModuleSetup.FindControl(pane);
			
			ArrayList modules = GetModules(pane);

			if (_listbox.SelectedIndex != -1) 
			{

				ModuleItem m = (ModuleItem) modules[_listbox.SelectedIndex];
				if (m.ModuleId > -1) 
				{
					// must delete from database too
					AdminDB admin = new AdminDB();
					admin.DeleteModule(m.ModuleId);

					//ĳÿ    
					PortalUtil.ResetCachedPortalSettingData();
				}
			}

			ModulePaneBind();
		}


		//*******************************************************
		//
		// The BindData helper method is used to update the tab's
		// layout panes with the current configuration information
		//
		//*******************************************************

		private void BindData() 
		{
			//  Ʈڽ ä.
			DataTable dtPages = new DataTable();
			DataRow dRow;

			dtPages.Columns.Add(new DataColumn("PageName", typeof(string)));
			dtPages.Columns.Add(new DataColumn("TargetID", typeof(Int32)));

			AdminDB admin = new AdminDB();
			SqlDataReader dr = admin.GetPagesOfTab(tabId);
			while (dr.Read()) 
			{
				dRow = dtPages.NewRow();

				dRow[0] = dr["PageName"];
				dRow[1] = dr["TargetID"];

				dtPages.Rows.Add(dRow);
			}
			dr.Close();
			lstboxPages.DataSource = dtPages.DefaultView;
			lstboxPages.DataBind();
			
			// Obtain PortalSettings from Current Context
			PortalSettings portalSettings = (PortalSettings) Context.Items["PortalSettings"];

			SqlDataReader drTab = admin.GetTab(tabId);
			drTab.Read();
			tabName.Text = drTab["TabName"].ToString();
			mobileTabName.Text = drTab["MobileTabName"].ToString();
			showMobile.Checked = Convert.ToBoolean(drTab["ShowMobile"]);
			// DB Ҷ Ѵ.
			ViewState["TabOrder"] = Convert.ToInt32(drTab["TabOrder"]);
			//templateFileName.Text = tab.PageTemplateName;

			// Clear existing items in checkboxlist
			tabAuthRoles.Items.Clear();

			ListItem allItem = new ListItem();
			allItem.Text = "All Users";

			string tabAuthorizedRoles = drTab["AuthorizedRoles"].ToString();
			drTab.Close();
			string[] aTabRoles = tabAuthorizedRoles.Split(new char[] {';'});

			if (Array.IndexOf(aTabRoles, "All Users") > -1)
			{
				allItem.Selected = true;
			}

			tabAuthRoles.Items.Add(allItem);

			// Populate checkbox list with all security roles for this portal
			// and "check" the ones already configured for this tab
			SqlDataReader roles = admin.GetPortalRoles(portalSettings.PortalId);
			
			while(roles.Read()) 
			{
				ListItem item = new ListItem();
				item.Text = (String) roles["RoleName"];
				item.Value = roles["RoleID"].ToString();
            
				if (Array.IndexOf(aTabRoles, item.Text) > -1) 
				{
					item.Selected = true;
				}

				tabAuthRoles.Items.Add(item);
			}
			roles.Close();

			// Populate the "Add Module" Data
			moduleType.DataSource = admin.GetModuleDefinitions(portalSettings.PortalId);
			moduleType.DataBind();
		}

		private void ModulePaneBind()
		{
			// Populate Right Hand Module Data
			rightList = GetModules("RightPane");
			RightPane.DataBind();

			// Populate Content Pane Module Data
			contentList = GetModules("ContentPane");
			contentPane.DataBind();

			// Populate Left Hand Pane Module Data
			leftList = GetModules("LeftPane");
			leftPane.DataBind();
		}
    
		//*******************************************************
		//
		// The GetModules helper method is used to get the modules
		// for a single pane within the tab
		//
		//*******************************************************

		private ArrayList GetModules (String pane) 
		{
			AdminDB admin = new AdminDB();
			SqlDataReader drModules = admin.GetPageModules(tabId, Convert.ToInt32(ViewState["pageid"]));

			ArrayList paneModules = new ArrayList();
			while (drModules.Read())
			{
				if (drModules["PaneName"].ToString().ToLower() == pane.ToLower()) 
				{
					ModuleItem m = new ModuleItem();
					m.ModuleTitle = drModules["ModuleTitle"].ToString();
					m.ModuleId = Convert.ToInt32(drModules["ModuleId"]);
					m.ModuleDefId = Convert.ToInt32(drModules["ModuleDefId"]);
					m.ModuleOrder = Convert.ToInt32(drModules["ModuleOrder"]);
					paneModules.Add(m);
				}
			}
			drModules.Close();

			return paneModules;
		}

		//*******************************************************
		//
		// The OrderModules helper method is used to reset the display
		// order for modules within a pane
		//
		//*******************************************************

		private void OrderModules (ArrayList list) 
		{
    
			int i = 1;
        
			// sort the arraylist
			list.Sort();
        
			// renumber the order
			foreach (ModuleItem m in list) 
			{
        
				// number the items 1, 3, 5, etc. to provide an empty order
				// number when moving items up and down in the list.
				m.ModuleOrder = i;
				i += 2;
			}
		}
        
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtnPageAdd.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtnPageAdd_Click);
			this.imgbtnPageSelect.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtnPageEdit_Click);
			this.imgbtnPageDelete.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtnPageDelete_Click);
			this.tabName.TextChanged += new System.EventHandler(this.PageSettings_Change);
			this.showMobile.CheckedChanged += new System.EventHandler(this.PageSettings_Change);
			this.mobileTabName.TextChanged += new System.EventHandler(this.PageSettings_Change);
			this.tabAuthRoles.SelectedIndexChanged += new System.EventHandler(this.PageSettings_Change);
			this.applyBtn.Click += new System.EventHandler(this.Apply_Click);
			this.lnkbtnPageUpdate.Click += new System.EventHandler(this.lnkbtnPageUpdate_Click);
			this.AddModuleBtn.Click += new System.EventHandler(this.AddModuleToPane_Click);
			this.LeftUpBtn.Click += new System.Web.UI.ImageClickEventHandler(this.UpDown_Click);
			this.LeftRightBtn.Click += new System.Web.UI.ImageClickEventHandler(this.RightLeft_Click);
			this.LeftDownBtn.Click += new System.Web.UI.ImageClickEventHandler(this.UpDown_Click);
			this.LeftEditBtn.Click += new System.Web.UI.ImageClickEventHandler(this.EditBtn_Click);
			this.LeftDeleteBtn.Click += new System.Web.UI.ImageClickEventHandler(this.DeleteBtn_Click);
			this.ContentUpBtn.Click += new System.Web.UI.ImageClickEventHandler(this.UpDown_Click);
			this.ContentLeftBtn.Click += new System.Web.UI.ImageClickEventHandler(this.RightLeft_Click);
			this.ContentRightBtn.Click += new System.Web.UI.ImageClickEventHandler(this.RightLeft_Click);
			this.ContentDownBtn.Click += new System.Web.UI.ImageClickEventHandler(this.UpDown_Click);
			this.ContentEditBtn.Click += new System.Web.UI.ImageClickEventHandler(this.EditBtn_Click);
			this.ContentDeleteBtn.Click += new System.Web.UI.ImageClickEventHandler(this.DeleteBtn_Click);
			this.RightUpBtn.Click += new System.Web.UI.ImageClickEventHandler(this.UpDown_Click);
			this.RightLeftBtn.Click += new System.Web.UI.ImageClickEventHandler(this.RightLeft_Click);
			this.RightDownBtn.Click += new System.Web.UI.ImageClickEventHandler(this.UpDown_Click);
			this.RightEditBtn.Click += new System.Web.UI.ImageClickEventHandler(this.EditBtn_Click);
			this.RightDeleteBtn.Click += new System.Web.UI.ImageClickEventHandler(this.DeleteBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void imgbtnPageEdit_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if (lstboxPages.SelectedIndex != -1)
			{
				lblPageMessage.Text = "õ  : ";

				int pageid = Convert.ToInt32(lstboxPages.SelectedItem.Value);
				ViewState["pageid"] = pageid;
				AdminDB admin = new AdminDB();
				SqlDataReader drPage = admin.GetPage(tabId, pageid);
				drPage.Read();
				txtPageName.Text = drPage["PageName"].ToString();
				txtPageTemplate.Text = drPage["PageTemplate"].ToString();
				placehdrPageSetup.Visible = true;
				lblPageMessage.Text += txtPageName.Text;
				ModulePaneBind();
				placehdrModuleSetup.Visible = true;

				PortalSettings portalSettings = (PortalSettings) Context.Items["PortalSettings"];

				// Clear existing items in checkboxlist
				pageAuthRoles.Items.Clear();

				ListItem allItem = new ListItem();
				allItem.Text = "All Users";

				string pageAuthorizedRoles = drPage["AuthorizedRoles"].ToString();
				drPage.Close();
				string[] aPageRoles = pageAuthorizedRoles.Split(new char[] {';'});
				
				if (Array.IndexOf(aPageRoles, "All Users") > -1)
				{
					allItem.Selected = true;
				}

				pageAuthRoles.Items.Add(allItem);

				// Populate checkbox list with all security roles for this portal
				// and "check" the ones already configured for this tab
				SqlDataReader roles = admin.GetPortalRoles(portalSettings.PortalId);
			
				while(roles.Read()) 
				{
					ListItem item = new ListItem();
					item.Text = (String) roles["RoleName"];
					item.Value = roles["RoleID"].ToString();
            
					if (Array.IndexOf(aPageRoles, item.Text) > -1)
					{
						item.Selected = true;
					}

					pageAuthRoles.Items.Add(item);
				}
				roles.Close();

				//string pageId = lstboxPages.SelectedItem.Value;
				//Response.Redirect(this.GetLink("-") + "&tabid=" + tabId + "&pageid=" + pageId);
			}
			else
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" õ Ⱦҽϴ.");
			}
		}

		private void lnkbtnPageUpdate_Click(object sender, System.EventArgs e)
		{
			AdminDB admin = new AdminDB();
			int pageId = Convert.ToInt32(ViewState["pageid"]);
			int newId;

			String authorizedRoles = "";

			foreach(ListItem item in pageAuthRoles.Items) 
			{
				if (item.Selected == true) 
				{
					authorizedRoles = authorizedRoles + item.Text + ";";
				}
			}

			int result = admin.SavePageData(tabId, pageId, txtPageName.Text, txtPageTemplate.Text, authorizedRoles, out newId);
			if (result == -1)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" ̸  ̹ մϴ.");
			else
			{
				ViewState["pageid"] = newId;
				BindData();
				//placehdrPageSetup.Visible = false;
				placehdrModuleSetup.Visible = true;
				ModulePaneBind();
				//  ϴ ĳ ͸ 
				HttpContext.Current.Cache.Remove("_AllPagesInfo");

				//ĳÿ    
				PowerOfDotNet.Components.PortalUtil.ResetCachedPortalSettingData();
			}
		}

		private void imgbtnPageDelete_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if (lstboxPages.SelectedIndex != -1)
			{
				AdminDB admin = new AdminDB();
				int result = admin.DeletePage(tabId, Convert.ToInt32(lstboxPages.SelectedItem.Value));
				if (result == -1)
					MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Modules̺  ڵ尡 ֽϴ.");
				else
				{
					BindData();
					placehdrPageSetup.Visible = false;
					placehdrModuleSetup.Visible = false;

					//ĳÿ    
					PowerOfDotNet.Components.PortalUtil.ResetCachedPortalSettingData();

				}
			}
			else
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" õ Ⱦҽϴ.");
		}

		private void imgbtnPageAdd_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			lblPageMessage.Text = "  ߰";
			int pageid = -1;
			ViewState["pageid"] = pageid;
			txtPageName.Text = "";
			txtPageTemplate.Text = "~/Templates/";
			placehdrPageSetup.Visible = true;
			placehdrModuleSetup.Visible = false;
		}
	}
}
