/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Clubs.Board
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using System.Text.RegularExpressions;

	/// <summary>
	///		ClubContentGroup   Դϴ.
	/// </summary>
	public abstract class ClubContentGroup : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.DataList GroupList;
		protected System.Web.UI.WebControls.DataList ContentList;
		//protected System.Web.UI.WebControls.Label Label1;
		private MidGroup _groupInfo;

		public MidGroup GroupInfo
		{
			get
			{
				return _groupInfo;
			}
			set
			{
				_groupInfo = value;
			}
		}

		private PowerOfDotNet.Components.BoardClubInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			int boardId = Convert.ToInt32(Request.Params["TableId"]);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardClubInfo)this.GetObjectFromCache("BoardClubTableInfo" + boardId);
			if (_blInfo == null)
			{
				PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardClubTableInfo" + boardId, _blInfo, 30);
			}
			//ContentList_ItemCommand ޼ҵ忡 ϱ 
			//̻ϰ ContentList_ItemCommandȿ  ä  ۵Ѵ.
			Context.Items["_blInfo"] = _blInfo;

			ContentList.DataSource = _groupInfo.PIDs;
			ContentList.DataBind();

			GroupList.DataSource = CreateDataSource();
			GroupList.DataBind();
			//this.DataBind();

			if (IsPostBack)
			{
				//ContentList_ItemCommand ̻ϰ  Ŭ κ Ҽ .
				//ItemCommand ġ ޼ҵó ϴ  . 
				//this ٸ ä νĵȴ.
				//Context.Items[this] = _groupInfo;
				//׷ ̷   Ѵ.
				Context.Items[_groupInfo.MID.ToString()] = _groupInfo;
			}
		}

		//Խù  ̰ ϴ Ķ͸ Ѵ.
		protected string GetContentUri(string pid)
		{
			string orgUri = Request.RawUrl;
			string pattern = @"&group\d+=" + _groupInfo.MID.ToString() + ":[^&]+&";
			string retUri = "";
			Regex groupRegex = new Regex(pattern);

			//Խ ˻  ߰Ѵ.
			if (orgUri[orgUri.Length-1] != '&')
				orgUri += "&";
			Match m = groupRegex.Match(orgUri);
			if ( m.Success )
			{
				string search = "=" + _groupInfo.MID.ToString();
				string newParm = m.Value.Substring(0, m.Value.IndexOf(search) + search.Length);
				newParm += ":" + pid.ToString() + "&";
				retUri = groupRegex.Replace(orgUri, newParm);
			}
			else
			{
				throw new Exception("Uri Ķ  ߸Ǿϴ.");
			}

			return retUri;
		}

		//Ÿҽ 
		private ICollection CreateDataSource()
		{
			
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("PID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Subject", typeof(string)));
			dt.Columns.Add(new DataColumn("Writer", typeof(string)));
			dt.Columns.Add(new DataColumn("Viewed", typeof(Int32)));
			dt.Columns.Add(new DataColumn("RegDate", typeof(string)));
			dt.Columns.Add(new DataColumn("Space", typeof(string)));
			dt.Columns.Add(new DataColumn("IsNew", typeof(bool)));
			dt.Columns.Add(new DataColumn("CommandArgument", typeof(string)));

			PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
			SqlDataReader sdr = db.GetListByMid(_blInfo.BBSTable, _groupInfo.MID);

			while (sdr.Read())
			{
				dr = dt.NewRow();

				dr[0] = sdr.GetInt64(0); //PID
				dr[1] = sdr.GetString(1); //Subject
				dr[2] = sdr.GetString(2); //Writer
				dr[3] = sdr.GetInt32(3); //ȸ
				dr[4] = sdr.GetDateTime(4).ToString("yyyy MM dd"); //RegDate
				DateTime dtRegDate = sdr.GetDateTime(4);
				dr[6] = dtRegDate >= DateTime.Now.AddDays(-1);//New ̹ ÷ 
				dr[7] = _groupInfo.MID.ToString() + ":" + sdr.GetInt64(0).ToString(); //Ŀ 

				string sEmail = sdr.GetString(5);
				// ּҰ  ũ
				if (sEmail != null && sEmail != String.Empty)
				{
					dr[2] = "<a href=\"mailto:" + sEmail + "\">" + dr[2] + "</a>";				
				}

				string sSpace = "";
				// 鿩
				for (int i=0;i<sdr.GetInt32(6);i++) 	sSpace += "&nbsp;&nbsp;";
				dr[5] = sSpace;

				dt.Rows.Add(dr);
			}
			sdr.Close();

			DataView dv = new DataView(dt);
			return dv;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
			this.ContentList.ItemCommand += new DataListCommandEventHandler(this.ContentList_ItemCommand);
		}
		#endregion

		//Request.RawUrl  pid  ּҸ Ѵ.
		protected string GetDeletedUri(string pid, string mid)
		{
			string orgUri = Request.RawUrl;
			string pattern = @"&group\d+=" + mid + ":[^&]+&";
			string retUri = "";
			Regex groupRegex = new Regex(pattern);

			//Խ ˻  ߰Ѵ.
			if (orgUri[orgUri.Length-1] != '&')
				orgUri += "&";
			
			Match m = groupRegex.Match(orgUri);
			if ( m.Success )
			{
				string[] aTmp = m.Value.Split(new char[] {':'});
				// ޺κп & ڰ Ƿ Ѵ.
				string[] aPIDs = aTmp[1].Replace("&", "").Split(new char[] {','});

				string paramPIDs = "";
				foreach (string s in aPIDs)
				{
					if (s != pid) // pidܿ ٸ pid ߰Ѵ.
						paramPIDs += "," + s;
				}
				if (paramPIDs.Length > 0)
				{
					//Uri ׷ȿ pid ϳ ̻̾  ĶŸ 
					paramPIDs = paramPIDs.Substring(1); //  ',' 
					string search = "=" + mid;
					string newParm = m.Value.Substring(0, m.Value.IndexOf(search) + search.Length);
					newParm += ":" + paramPIDs + "&";
					retUri = groupRegex.Replace(orgUri, newParm);
				}
				else
				{
					//Uri ׷ȿ pid ϳ ׷쵵 
					retUri = groupRegex.Replace(orgUri, "&");
				}
				//׷ ϳ     Ƿ
				//  Uri ؾѴ.
				pattern = @"&group\d+=\d+:[^&]+&";
				groupRegex = new Regex(pattern);
				m = groupRegex.Match(retUri);
				if (!m.Success)
				{
					retUri = GetLink(_blInfo.BBSPageNameList);
					string page = "&page=" + MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["page"], "0");
					string tableId = "&TableId=" + Request.Params["TableId"].ToString();
					string clubId = "&clubId=" + Request.Params["clubId"].ToString();
					
					/*
					int sqlLev = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["sqllev"], 0);
					string sqlParam = "";
					if (sqlLev > 0)
					{
						sqlParam = "&sqllev=" + sqlLev.ToString();
						for (int i=1; i<=sqlLev; i++)
						{
							string tmpSql = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["sql" + i.ToString()], "");
							if (tmpSql != "")
							{
								sqlParam += "&sql" + i.ToString() + "=" + tmpSql;
							}
						}
					}
					*/
					retUri += page + clubId + tableId;
				}

				return retUri;
			}
			else
			{
				throw new Exception("Uri Ķ  ߸Ǿϴ.");
			}
		}

		private void ContentList_ItemCommand(object source, System.Web.UI.WebControls.DataListCommandEventArgs e)
		{
			string sCommandName = e.CommandName;
			string sCommandArgument = e.CommandArgument.ToString();

			string[] aCmd = sCommandArgument.Split(new Char[] {':'});
			/*
			//⼭ Ʒó ϸ tmpMd null ȴ.(̻ϴ??)
			//MidGroup tmpMd = Context.Items[this]
			MidGroup tmpMd = (MidGroup)Context.Items[aCmd[0]];
			*/

			int clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			PowerOfDotNet.Components.BoardClubInfo blInfo = (PowerOfDotNet.Components.BoardClubInfo)Context.Items["_blInfo"];

			switch (sCommandName)
			{
				case "Edit":
					// Uri Ķ͸  Ѵ.
					// ģ  ּҷ ٽ ƿü ֵ
					string retBefore = Request.RawUrl.Replace("&","$").Replace("=","^");
					string pid = "pid=" + aCmd[0];
					string genParam = Clubs.ClubsUtil.GetGenParam();
					Response.Redirect(GetLink(blInfo.BBSPageNameEdit) + 
						"&" + pid + "&" + genParam + "&TableId=" + aCmd[1] + 
						"&clubId=" + clubId + "&before=" + retBefore);
					break;
				case "Delete":

					Components.ClubInfo clubInfo = Clubs.ClubsUtil.GetClubInfo(this, clubId);
					bool gongJiAuthority = Clubs.ClubsUtil.CheckUserAuthorityForGongJi(Page.User.Identity.Name, clubInfo, _blInfo);
					if (!gongJiAuthority) MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Ŭ ڸ   ֽϴ.");

					PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
					int result = db.DeleteOne(aCmd[2], int.Parse(aCmd[1]), int.Parse(aCmd[0]));
					if (result == -1)
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" ־  ϴ.");
					else if (result == -2)
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Խù    ߻߽ϴ.");

					Response.Redirect(GetDeletedUri(aCmd[1], aCmd[0]));

					break;
				case "Reply":
					// Uri Ķ͸  Ѵ.
					// ģ  ּҷ ٽ ƿü ֵ
					string retRBefore = Request.RawUrl.Replace("&","$").Replace("=","^");
					string pidR = "pid=" + aCmd[0];
					string genParamR = Clubs.ClubsUtil.GetGenParam();
					Response.Redirect(GetLink(blInfo.BBSPageNameReply) + 
						"&" + pidR + "&" + genParamR + "&clubId=" + clubId +
						"&TableId=" + aCmd[1] + "&before=" + retRBefore);
					break;
				/*case "Select":
					tmpMd.PIDs.Clear();
					tmpMd.AddPid(Convert.ToInt32(aCmd[1]));
					tmpMd.ChangedPID = Convert.ToInt32(aCmd[1]);
					break;*/
			}
		}
	}
}
