/*
 *  - 2003 10 26
 */

namespace PowerOfDotNet.Templates
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		AdminTemplate01   Դϴ.
	/// </summary>
	public abstract class ClubsTemplate01 : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.HtmlControls.HtmlTableCell ContentPane;
		protected System.Web.UI.WebControls.DropDownList drpdnlstMyClubs;


		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				this.DataBind();
				if (Request.IsAuthenticated) {
					//α 밡  ŬƮ   ֵ
					PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
					SqlDataReader dr = db.GetUserClubs(this.Page.User.Identity.Name);
					drpdnlstMyClubs.DataSource = dr;
					drpdnlstMyClubs.DataValueField = "ClubID";
					drpdnlstMyClubs.DataTextField = "Subject";
					drpdnlstMyClubs.DataBind();
					drpdnlstMyClubs.Items.Insert(0, new ListItem("----   Ŭ ----", ""));
					drpdnlstMyClubs.SelectedIndex = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["dlIdx1"], 0);
				}
				else {
					drpdnlstMyClubs.Items.Add(new ListItem("---- α  밡 ----", ""));
					drpdnlstMyClubs.Enabled = false;
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{

			base.OnInit(e);

			//Ʈ  εҶ ̷
			//InitializeComponent base.OnInit  ȣǾѴ.
			//OnInit޼ҵ忡  Ʈ  Ե Ʈѵ ʱȭ ȴ.
			InitializeComponent();

			// Obtain PortalSettings from Current Context
			PortalSettings portalSettings = (PortalSettings) HttpContext.Current.Items["PortalSettings"];
        
			// Ensure that the visiting user has access to the current page
			// ǰ  ׼   ˻Ѵ.
			if (PortalSecurity.IsInRoles(((TabStripDetails)portalSettings.DesktopTabs[portalSettings.ActivePage.TabIndex]).AuthorizedRoles) == false ||
				PortalSecurity.IsInRoles(portalSettings.ActivePage.AuthorizedRoles) == false) 
			{
				if (!PortalSecurity.IsInRole("Users"))
					Response.Redirect(GetLink("α") + "&ReturnUrl=" + Request.RawUrl.Replace("&","$"));
				else
					Response.Redirect("~/Admin/AccessDenied.aspx");
			}

			// Dynamically Populate the Left, Center and Right pane sections of the portal page
			if (portalSettings.ActivePage.Modules.Count > 0) 
			{

				// Loop through each entry in the configuration system for this tab
				foreach (ModuleSettings _moduleSettings in portalSettings.ActivePage.Modules) 
				{

					//O Control ø ֽ̹ ֱ⶧ FindControlδ ã.
					Control parent = MyWebLibs.Utilities.CommonMethods.FindControlAll(this, _moduleSettings.PaneName);

					// If no caching is specified, create the user control instance and dynamically
					// inject it into the page.  Otherwise, create a cached module instance that
					// may or may not optionally inject the module into the tree

					if ((_moduleSettings.CacheTime) == 0) 
					{
						PortalModuleControl portalModule = (PortalModuleControl) Page.LoadControl(_moduleSettings.DesktopSrc);
                   
						portalModule.PortalId = portalSettings.PortalId;                                  
						portalModule.ModuleConfiguration = _moduleSettings;
                   
						parent.Controls.Add(portalModule);
					}
					else 
					{
						//CachedPortalModuleControlEx portalModule = new CachedPortalModuleControlEx();
						CachedPortalModuleControl portalModule = new CachedPortalModuleControl();
                   
						portalModule.PortalId = portalSettings.PortalId;                                 
						portalModule.ModuleConfiguration = _moduleSettings;
 
						parent.Controls.Add(portalModule);
					}

					// Dynamically inject separator break between portal modules
					//parent.Controls.Add(new LiteralControl("<" + "br" + ">"));
					parent.Visible = true;
				}
			}

			int clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);

			if (clubId != -1) {
				string userId = Page.User.Identity.Name;
				bool isClubMaster = Clubs.ClubsUtil.CheckUserIsAdmin(userId);
				
				//߱Ⱓ ȸ
				//string casheKey = "objClub_" + clubId;
				//this.RemoveObjectCache(casheKey);

				Components.ClubInfo clubInfo = Clubs.ClubsUtil.GetClubInfo(this, clubId);

				//Ŭ  Free ƴҰ ٱ ˻
				if (clubInfo.publicType > 0 && !isClubMaster) {
					PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();

					int result = db.CheckClubUser(clubId, userId);
					if (result == -1)
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ȸ   ִ ŬԴϴ.");
					if (clubInfo.publicType == 2 && result == 0)
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" û   Ⱦҽϴ.");
				}

				//湮 ȸ 
				if (this.Page.Session["ClubVisited" + clubId] == null && !isClubMaster) {
					PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
					db.UserVisitedCountIncrease(clubId, userId);
					this.Page.Session["ClubVisited" + clubId] = "visited";
				}
			}
		}
		
		private void InitializeComponent()
		{
			this.drpdnlstMyClubs.SelectedIndexChanged += new System.EventHandler(this.drpdnlstMyClubs_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void drpdnlstMyClubs_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (((DropDownList)sender).SelectedIndex == 0)
				Response.Redirect(GetLink("Ŭ"));
			else {
				int id = Convert.ToInt32(((DropDownList)sender).SelectedItem.Value);
				Response.Redirect(GetLink("Ŭ") + "&clubId=" + id + "&dlIdx1=" + ((DropDownList)sender).SelectedIndex);
			}
		}
	}
}
